/**
 * 度数の検定
 * ２×２表(Fisher's exact test)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
//セルデータの消去
function clearCellData() {
	var i = 1;
	var elmCount = 4;

	var result = confirm("データを消去します");
	if (result === true) {
		for (i = 1; i < 5; i++) {
			document.getElementById("cell_" + i).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("cell_sum").value = "";
		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
//入力チェック
function checkCellData() {
	var i = 1;
	var iCount = 2;
	var jCount = 2;
	var elmCount = iCount * jCount;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell_" + i).value === "") {
				errorCellNum = i;
			}
		}

		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			sum();
			mainCalc_2x2();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		conditionalBranch();
		copipe("CandPArea", "text");
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
		sum();
		checkCellData();
	}
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	if (dd.length > 2 * 2) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;
	var j = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var err = false;

	var NN = countRowCol("CandPArea")[0]; // 行数を取得
	var KK = countRowCol("CandPArea")[1]; // 列数を取得

	// if (dd.length % 2 !== 0) { //データ個数が偶数であること
	// 	err = true;
	// }

	if (NN === 2) {
		err = true;
	}

	if (KK === -1) { //データが行列形式でない
		err = true;
	}

	if (err === false) {
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) == 1) || (parseInt(dd[i]) == 2)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var groupValue = new Array(2);
			for (i = 0; i < 2; i++) {
				groupValue[i] = new Array(2);
			}

			for (i = 0; i < 2; i++) {
				for (j = 0; j < 2; j++) {
					groupValue[i][j] = 0;
				}
			}

			for (i = 0; i < dd.length; i = i + 2) {
				groupValue[dd[i] - 1][dd[i + 1] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < 2; i++) {
				for (j = 0; j < 2; j++) {
					strArray.push(groupValue[i][j]);
					strArray.push("\t");
				}
				strArray.push("\n");
			}
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
//メインの計算
function mainCalc_2x2() {
	var i = 0;
	var DD1 = parseInt(document.getElementById("cell_1").value);
	var DD2 = parseInt(document.getElementById("cell_2").value);
	var DD3 = parseInt(document.getElementById("cell_3").value);
	var DD4 = parseInt(document.getElementById("cell_4").value);

	var A = DD1;
	var B = DD2;
	var C = DD3;
	var D = DD4;

	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M4  M3 | NN

	var NN = A + B + C + D;
	document.getElementById("cell_sum").value = NN;

	var svA = A; //A～Dの値を保存(save)しておく
	var svB = B;
	var svC = C;
	var svD = D;

	var raA = (A / (A + B)).toFixed(4);  //A～Dの比率(ratio)
	var raB = (B / (A + B)).toFixed(4);
	var raC = (C / (C + D)).toFixed(4);
	var raD = (D / (C + D)).toFixed(4);

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var strArray = [];
	var rcmArray = [];

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NN] = logfact(NN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}

	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}

	strArray.push("[直接確率計算２×２]\n\n");
	strArray.push("\t観測値１\t観測値２\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + DD1 + "\t" + DD2 + "\n");
	strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("群２\t" + DD3 + "\t" + DD4 + "\n");
	strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------" + "\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");

	//Phiの計算（常に出力する）
	M1 = svA + svB;
	M2 = svC + svD;
	M3 = svA + svC;
	M4 = svB + svD;

	// var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));
	var Phi = Math.sqrt(Math.pow(Math.abs(svA * svD - svB * svC) - NN / 2, 2) / (M1 * M2 * M3 * M4));
	// x2 = N * Math.pow(Math.abs(xx[0][0] * xx[1][1] - xx[0][1] * xx[1][0]) - N / 2, 2) / (T[0] * T[1] * Y[0] * Y[1]);

	var phi = Phi.toFixed(3);

	strArray.push("連関係数 : Phi=" + phi + " （イエーツの補正適用）\n");

	//効果量の計算（常に出力する）
	var effectSizeH = 2 * Math.asin(Math.sqrt(raA)) - 2 * Math.asin(Math.sqrt(raC));
	strArray.push("効果量 : h=" + effectSizeH.toFixed(4) + "\n");
	strArray.push("\t\t（大=0.8 , 中=0.5 , 小=0.2）\n");

	strArray.push("-----------------------------------------\n");

	//オッズ比計算
	strArray.push("\n");
	strArray.push("[オッズ比検定]\n\n");
	strArray.push("\t観測値１\t観測値２\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + svA + "\t" + svB + "\n");
	strArray.push("群２\t" + svC + "\t" + svD + "\n");
	strArray.push("-----------------------------------------" + "\n\n");

	if ((svA === 0) || (svB === 0) || (svC === 0) || (svD === 0)) {
		svA = svA + 0.5;
		svB = svB + 0.5;
		svC = svC + 0.5;
		svD = svD + 0.5;

		strArray.push("＜修正値＞\n");
		strArray.push("\t観測値１\t観測値２\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("群１\t" + svA + "\t" + svB + "\n");
		strArray.push("群２\t" + svC + "\t" + svD + "\n");
		strArray.push("-----------------------------------------" + "\n");
		strArray.push("観測値に０があったので,＋0.5で修正しました。\n\n");
	}

	//NN = A+B+C+D;

	var os;
	var se;
	var kagen;
	var jogen;
	var hantei;

	os = (svA * svD) / (svB * svC);
	se = Math.sqrt(1 / svA + 1 / svB + 1 / svC + 1 / svD);
	kagen = os * Math.exp(-1.96 * se); //両側検定
	jogen = os * Math.exp(1.96 * se);

	hantei = "有意でない";
	if ((kagen < 1) && (jogen < 1)) {
		hantei = "有意である";
	}
	if ((kagen > 1) && (jogen > 1)) {
		hantei = "有意である";
	}

	strArray.push("オッズ比:  =" + using(os, 4, 2) + "\n\n");
	strArray.push("＜両側検定＞\n");
	strArray.push("下限値  :  =" + using(kagen, 4, 2) + "\n");
	strArray.push("上限値  :  =" + using(jogen, 4, 2) + "\n");
	strArray.push("オッズ比による検定は," + hantei + "(95%信頼区間,両側)\n");

	if (os < 1) { //片側検定
		kagen = 0;
		jogen = os * Math.exp(1.645 * se);
	} else {
		kagen = os * Math.exp(-1.645 * se);
		jogen = "∞";
	}

	hantei = "有意でない";
	if (jogen < 1) {
		hantei = "有意である";
	}
	if (kagen > 1) {
		hantei = "有意である";
	}

	strArray.push("\n");
	strArray.push("＜片側検定＞\n");

	if (os < 1) {
		strArray.push("下限値  :  =" + using(kagen, 4, 2) + "\n");
		strArray.push("上限値  :  =" + using(jogen, 4, 2) + "\n");
	} else {
		strArray.push("下限値  :  =" + using(kagen, 4, 2) + "\n");
		strArray.push("上限値  :  = ∞\n");
	}

	strArray.push("オッズ比による検定は," + hantei + "(95%信頼区間,片側)\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	if (document.getElementById("RltAdd").checked) {
		document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	} else {
		document.getElementById("RltArea").value = strArray.join("");
	}
	strArray = null;

	//Ｒプログラム出力
	(function () {
		rcmArray.push("##### ２×２表(Fisher's exact test)\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		rcmArray.push("ds11=" + DD1 + "  # 群１の値１\n");
		rcmArray.push("ds12=" + DD2 + "  # 群１の値２\n");
		rcmArray.push("\n");
		rcmArray.push("ds21=" + DD3 + "  # 群２\n");
		rcmArray.push("ds22=" + DD4 + "\n");
		rcmArray.push("\n");
		var shinrai = document.getElementById("shinrai").value;
		rcmArray.push("shinrai= " + shinrai + " # 信頼水準\n");
		rcmArray.push("## js-STARからの入力おわり\n");
		rcmArray.push("\n");
		rcmArray.push("# main\n");
		rcmArray.push("gun1= c(ds11, ds12)\n");
		rcmArray.push("gun2= c(ds21, ds22)\n");
		rcmArray.push("N= sum(gun1, gun2 )\n");
		rcmArray.push("n1=sum(gun1); n2=sum(gun2)\n");
		rcmArray.push("tx1 = matrix(c(ds11,ds12, ds11/n1,ds21,ds22, ds21/n2), nr=2,by=1 )\n");
		rcmArray.push("rownames(tx1)= c(\"群１\",\"群２\" )\n");
		rcmArray.push("colnames(tx1)= c(\"値１\",\" 値２\",\" 値１の比率\" )\n");
		rcmArray.push("\n");
		rcmArray.push("## 作図\n");
		rcmArray.push("zhyo= matrix( c(gun2/n2, gun1/n1 ), nc=2, by=1 )\n");
		rcmArray.push("rownames(zhyo)= c(\"群２\", \"群１\") # 群２先\n");
		rcmArray.push("maintitle=\"値１(黒)と値２(白)の比率\"\n");
		rcmArray.push("barplot(t(zhyo),hor=1,main=maintitle,las=1,cex.ax=1.5,cex.na=1.5 )\n");
		rcmArray.push("\n");
		rcmArray.push("P1= c( ds11/n1 )\n");
		rcmArray.push("P2= c( ds21/n2 )\n");
		rcmArray.push("ESh= abs(2*asin(sqrt(P1))-2*asin(sqrt(P2)) )\n");
		rcmArray.push("\n");
		rcmArray.push("## 片側\n");
		rcmArray.push("if( P1>=P2 ){ H1=\"g\"; mds=\"群1>群2\" } else { H1=\"l\"; mds=\"群1<群2\" }\n");
		rcmArray.push("\n");
		rcmArray.push("kFS=c();kPR=c()\n");
		rcmArray.push("kFS= fisher.test(tx1[1:2,1:2],al=H1,conf.lev=shinrai )\n");
		rcmArray.push("kPR= prop.test(tx1[1:2,1:2],al=H1,conf.lev=shinrai,cor=1)\n");
		rcmArray.push("\n");
		rcmArray.push("tk1= c()\n");
		rcmArray.push("tk1= matrix( round(kFS$p.va, 4), nr=1 )\n");
		rcmArray.push("rownames(tk1)= paste(\"対立仮説\",mds )\n");
		rcmArray.push("colnames(tk1)= c( \"    ｐ値\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tk2= c()\n");
		rcmArray.push("pow= 1-pchisq(qchisq(0.90,df=1),df=1, ncp=kPR$stat )\n");
		rcmArray.push("ESw= sqrt( kPR$stat/N )\n");
		rcmArray.push("tk2= matrix(round(c(kPR$stat,1,kPR$p.va,ESw,pow), 4), nr=1 )\n");
		rcmArray.push("rownames(tk2)= rownames(tk1)\n");
		rcmArray.push("colnames(tk2)= c(\"χ2 値\",\"df\",\"ｐ値\",\"効果量ｗ\",\"検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tk3 = c() # 信頼区間\n");
		rcmArray.push("tk3 = matrix(round(c(ds11/n1-ds21/n2,kPR$conf[1:2], kFS$est,kFS$conf[1:2]), 4), nr=2,by=1 )\n");
		rcmArray.push("rownames(tk3)= c(\"比率の差\",\"オッズ比\" )\n");
		rcmArray.push("colnames(tk3)= c(\" 点推定\", paste(shinrai*100,\"％信頼下限\",sep=\"\"),\"    上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 両側\n");
		rcmArray.push("H1=\"t\"; mds=\"両側検定\"\n");
		rcmArray.push("\n");
		rcmArray.push("kx1=c(); kx2=c()\n");
		rcmArray.push("kx1= fisher.test(tx1[1:2,1:2],al=H1,conf.lev=shinrai )\n");
		rcmArray.push("kx2= prop.test(tx1[1:2,1:2],al=H1,conf.lev=shinrai,cor=1 )\n");
		rcmArray.push("\n");
		rcmArray.push("tr1= c()\n");
		rcmArray.push("tr1= matrix(round(kx1$p.va, 4), nr=1 )\n");
		rcmArray.push("rownames(tr1)=\"両側検定\"\n");
		rcmArray.push("colnames(tr1)=\"    ｐ値\"\n");
		rcmArray.push("\n");
		rcmArray.push("tr2= c()\n");
		rcmArray.push("Pow= 1-pchisq(qchisq(0.95,df=1),df=1, ncp=kx2$stat )\n");
		rcmArray.push("ESw= sqrt( kx2$stat/N )\n");
		rcmArray.push("tr2= matrix(round(c(kx2$stat,1,kx2$p.va,ESw,Pow), 4), nr=1 )\n");
		rcmArray.push("rownames(tr2)= rownames(tr1)\n");
		rcmArray.push("colnames(tr2)= colnames(tk2)\n");
		rcmArray.push("\n");
		rcmArray.push("tr3 = c() # 信頼区間\n");
		rcmArray.push("tr3 = matrix(round(c(ds11/n1-ds21/n2,kx2$conf[1:2], kx1$est,kx1$conf[1:2]), 4), nr=2,by=1 )\n");
		rcmArray.push("rownames(tr3)= c(\"比率の差\",\"オッズ比\" )\n");
		rcmArray.push("colnames(tr3)= c(\" 点推定\", paste(shinrai*100,\"％信頼下限\",sep=\"\"),\"    上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("NN= c(NA,NA) # パワ\n");
		rcmArray.push("if( Pow<0.80 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" for( i in (N-1):10000 )\n");
		rcmArray.push("   {\n");
		rcmArray.push("    beta= pchisq(qchisq(0.95,1),1, ncp=ESw^2*i )\n");
		rcmArray.push("    if( beta<0.20 ){ NN=c(i,1-beta,NN); break }\n");
		rcmArray.push("   }\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" for( i in (N+1):0 )\n");
		rcmArray.push("   {\n");
		rcmArray.push("    beta= pchisq(qchisq(0.95,1),1, ncp=ESw^2*i )\n");
		rcmArray.push("    if( beta>0.20 ) break\n");
		rcmArray.push("    NN= c(i,1-beta, NN )\n");
		rcmArray.push("   }\n");
		rcmArray.push("}\n");
		rcmArray.push("tx4= c()\n");
		rcmArray.push("tx4= matrix(round(c(ESw,0.05,NN[2],NN[1],N),4), nr=1 )\n");
		rcmArray.push("rownames(tx4)=\"\"\n");
		rcmArray.push("colnames(tx4)= c(\"効果量ｗ\",\"   α\",\" 検出力\",\"次回Ｎ\",\"今回Ｎ\" )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# ■結果の書き方\n");
		rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray.push("txt= c()\n");
		rcmArray.push("txt=\"　Table(tx1)は群×値の度数集計表である。\n　Table(tx1)においてFisherの正確検定を行った結果，有意\"\n");
		rcmArray.push("pch= tr1\n");
		rcmArray.push("\n");
		rcmArray.push("tmp=c(); goku=\"，\"\n");
		rcmArray.push("if( pch<0.05 ) tmp=\"であり\" else\n");
		rcmArray.push("if( pch<0.10 ) tmp=\"傾向であり\" else { tmp=\"ではなかった\"; goku=\"。\" }\n");
		rcmArray.push("fuki= paste(\" (p=\",PV(pch),\", odds ratio=\",round(tr3[2,1],3),\", 両側検定)\", sep=\"\" )\n");
		rcmArray.push("txt= paste(txt, tmp,fuki,goku, sep=\"\" )\n");
		rcmArray.push("if( pch<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" tmp=\"大きい\"; if(P1<P2) tmp=\"小さい\"\n");
		rcmArray.push(" goku=\"傾向がある\"; if( pch<0.05 ) goku=\"\"\n");
		rcmArray.push(" txt= paste(txt, \"群１の値1の比率が群２の値1の比率よりも有意に\",tmp,goku,\"ことが見いだされた。なおオッズ比は条件付き最尤推定値である。\", sep=\"\" )\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("yosh= 1\n");
		rcmArray.push("fuki= paste(\" (w=\",round(ESw,3),\", 1-β=\",round(tr2[5],3),\")。\", sep=\"\" )\n");
		rcmArray.push("if( ESw>=0.5 ) tmp=\"大きい\" else\n");
		rcmArray.push("if( ESw>=0.3 ) tmp=\"中程度以上\" else\n");
		rcmArray.push("if( ESw>=0.26) tmp=\"ほぼ中程度\" else { tmp=\"小さい\"; yosh=0 }\n");
		rcmArray.push("txt= paste(txt, \"連続性修正χ2値より算出した効果量wは便宜的基準 (Cohen, 1992) によると\",tmp,\"と判断される\",fuki, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("if( pch<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" mata=\"また\"\n");
		rcmArray.push(" goku=\"検出力（1-β）は\"\n");
		rcmArray.push(" if( Pow<0.70 ){ tmp=\"不十分であり，信頼性が低い。\"; if(yosh>0) mata=\"ただし\" } else\n");
		rcmArray.push(" if( Pow<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない。\" else\n");
		rcmArray.push(" if( Pow<0.80 ) tmp=\"ほぼ十分といえる。\" else tmp=\"十分である。\"\n");
		rcmArray.push(" txt= paste(txt, mata,goku,tmp, sep=\"\" )\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("tmp= paste(shinrai*100,\"信頼区間は\",sep=\"％\" )\n");
		rcmArray.push("goku=\"と推定される。\"\n");
		rcmArray.push("txt= paste(txt, \"\n　群１の群２に対するオッズ比について，その\",tmp,round(tr3[2,2],3),\" - \",round(tr3[2,3],3),goku,\"また，群１と群２の値１の比率差について，その\",tmp,round(tr3[1,2],3),\" - \",round(tr3[1,3],3),goku, sep=\"\" )\n");
		rcmArray.push("txt= paste(txt, \"\n\n［引用文献］\n\",\n");
		rcmArray.push("\"Cohen, J. (1992). A power primer. Psychological Bulletin, 112, 155-159.\n\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=4)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("################################\n");
		rcmArray.push("# ２×２表の分析\n");
		rcmArray.push("# ・Ｆisher の正確検定（片側）\n");
		rcmArray.push("# ・独立比率の差の検定（片側）\n");
		rcmArray.push("################################\n");
		rcmArray.push("tx1 # 度数集計表\n");
		rcmArray.push("\n");
		rcmArray.push("tk1 # フィッシャーの正確検定\n");
		rcmArray.push("\n");
		rcmArray.push("tk2 # 独立比率の差の検定（連続性修正）\n");
		rcmArray.push("\n");
		rcmArray.push("tk3 # 点推定と信頼区間推定\n");
		rcmArray.push("\n");
		rcmArray.push("################################\n");
		rcmArray.push("# ２×２表の分析\n");
		rcmArray.push("# ・Ｆisher の正確検定（両側）\n");
		rcmArray.push("# ・独立比率の差の検定（両側）\n");
		rcmArray.push("################################\n");
		rcmArray.push("tx1 # 度数集計表\n");
		rcmArray.push("\n");
		rcmArray.push("tr1 # フィッシャーの正確検定\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 # 独立比率の差の検定（連続性修正）\n");
		rcmArray.push("# 効果量ｗの評価：大=0.5, 中=0.3, 小=0.1\n");
		rcmArray.push("# 効果量ｗは連続性修正χ2値より算出\n");
		rcmArray.push("\n");
		rcmArray.push("tr3 # 点推定と信頼区間推定\n");
		rcmArray.push("# オッズ比の計算は条件付き最尤推定による\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 # パワーアナリシス（追試用Ｎの計算）\n");
		rcmArray.push("\n");
		rcmArray.push("cat(txt) # 結果の書き方\n");
		rcmArray.push("\n");
		rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# ESh # 効果量ｈ:大=0.8, 中=0.5, 小=0.2\n");
		rcmArray.push("# write(txt, file.choose(), ap=T) # 結果のファイル保存\n");
		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
		rcmArray.push("\n");

		if (document.getElementById("RltAdd").checked) {
			document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
		} else {
			document.getElementById("RcmArea").value = rcmArray.join("");
		}
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		if (document.getElementById("RltAdd").checked === false) {
			chartClear();
		}

		var parent = document.getElementById("chart");
		var childElementCount = parent.childElementCount;

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg" + childElementCount;
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < 2; i++) {
			data[i] = [];
		}
		data[0][0] = (raA * 100).toFixed(4);
		data[0][1] = (raC * 100).toFixed(4);
		data[1][0] = (raB * 100).toFixed(4);
		data[1][1] = (raD * 100).toFixed(4);

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}
		for (i = 0; i < 2; i++) {
			datasetKey[i].label = '値' + (i + 1);
			datasetKey[i].data = data[i];
			datasetKey[i].backgroundColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
			datasetKey[i].borderColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
			datasetKey[i].borderWidth = 1;
		}

		var datasetData = [];
		// var dataset = [datas[0], datas[1]];
		for (i = 0; i < 2; i++) {
			datasetData[i] = datasetKey[i];
		}
		var myChart = new Chart(ctx, {
			type: 'horizontalBar',
			data: {
				labels: ['群１', '群２'],
				datasets: datasetData
			},
			options: {
				title: {
					display: true,
					text: '値１（黒）と値２（灰白）の比率',
					position: 'top',
					fontSize: 12,
					fontColor: '#000000'
				},
				scales: {
					xAxes: [{
						stacked: true,
						ticks: {
							beginAtZero: true,
							min: 0,
							max: 100
						}
					}],
					yAxes: [{
						stacked: true
					}]
				},
				legend: {
					position: 'bottom'
				}
			}
		});
	}());

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
function sum() {
	var i = 1;
	var iCount = 2;
	var jCount = 2;
	var elmCount = iCount * jCount;

	var wSum = 0;

	for (i = 1; i < elmCount + 1; i++) {
		if (isNaN(parseInt(document.getElementById("cell_" + i).value)) === false) {
			wSum += parseInt(document.getElementById("cell_" + i).value);
		}
	}
	document.getElementById("cell_sum").value = wSum;
}
function saveData_2x2() {
	var i, j;

	var strArray = [];

	var DD1 = parseInt(document.getElementById("cell_1").value);
	var DD2 = parseInt(document.getElementById("cell_2").value);
	var DD3 = parseInt(document.getElementById("cell_3").value);
	var DD4 = parseInt(document.getElementById("cell_4").value);

	strArray.push(DD1 + "\t" + DD2 + "\n");
	strArray.push(DD3 + "\t" + DD4 + "\n");

	var Stream = strArray.join("");
	var fineName = "2x2_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function simulation_2x2(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var result = "rnd1:2*50*2";
	var N = "";
	if (key_shift) {
		N = prompt("Nを入力してください");
		if (N === null) {
			result = "rnd1:2*50*2";
		}
		if (N !== "") {
			if (isNaN(N)) {
				N = 50;
			}
			result = "rnd1:2*" + parseInt(N, 10) + "*2";
		}
	} else {
		if (document.getElementById("cell_sum").value !== "") {
			result = "rnd1:2*" + document.getElementById("cell_sum").value + "*2";
		} else {
			result = "rnd1:2*50*2";
		}
	}

	document.getElementById("CandPArea").value = random_number_generation(result);

	conditionalBranch();
	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// inputBtnTextClear(this);
	sum();

	mainCalc_2x2();
}