/**
 * 度数の検定
 * １×２表：母比率不等
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
//セルデータの消去
function clearCellData() {
	var result = confirm("データを消去します");
	if (result === true) {
		// 観測値のセル
		document.getElementById("cell_1").value = "";
		document.getElementById("cell_2").value = "";

		// 母比率のセル
		document.getElementById("cell2_1").value = "";
		document.getElementById("cell2_2").value = "";

		errorClearCell(2, "");
		errorClearCell(2, "2");
		document.getElementById("cell_sum").value = "";
	}
	document.getElementById("cell_1").focus();
}
//入力チェック
function checkCellData() {
	var i = 1;
	var elmCount = 2; //観測値と母比率それぞれ２つずつ
	var errorCellNum = 0;

	// 観測値のセル
	errorClearCell(2, "");
	errorCell(2, "");

	// 母比率のセル
	errorClearCell(2, "2");
	errorCell(2, "2");

	for (i = 1; i < elmCount + 1; i++) {
		if (document.getElementById("cell_" + i).value === "") {
			errorCellNum = i;
		}
	}

	if (errorCellNum == 0) {
		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell2_" + i).value === "") {
				errorCellNum = i;
			}
		}

		if (errorCellNum === 0) {
			errorClearCell(2, "");
			errorClearCell(2, "2");
			sum();
			mainCalc_futo1x2();
		} else {
			alert("すべての母比率が入力されていません (^_^)ゞ");
			document.getElementById("cell2_" + errorCellNum).focus();
		}
	} else {
		alert("すべての度数が入力されていません (^_^)ゞ");
		document.getElementById("cell_" + errorCellNum).focus();
	}
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	if (dd.length == 2) {
		// 観測値のみ代入，母比率は空白
		copipe('CandPArea', 'text');
		document.getElementById("cell2_1").value = "";
		document.getElementById("cell2_2").value = "";
	} else if (dd.length == 2 * 2) {
		copipe2('CandPArea', 'text', 'text_ratio');
	} else if (dd.length > 2 * 2) {
		crossTabulate();
		// 観測値のみ代入，母比率は空白
		copipe('CandPArea', 'text');
		document.getElementById("cell2_1").value = "";
		document.getElementById("cell2_2").value = "";
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i;
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var yoko = 2;
	var err = false;

	if (err == false) {
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) == false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < yoko + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err == false) {
			var gunAtai = new Array(yoko);
			for (i = 0; i < yoko; i++) {
				gunAtai[i] = 0;
			}

			for (i = 0; i < dd.length; i++) {
				gunAtai[dd[i] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < yoko; i++) {
				strArray.push(gunAtai[i]);
				strArray.push("\t");
			}
			strArray.push("\n");
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
// メインの計算
function mainCalc_futo1x2() {
	var KK1 = parseInt(document.getElementById("cell_1").value, 10);
	var KK2 = parseInt(document.getElementById("cell_2").value, 10);
	var sKK1 = KK1;
	var sKK2 = KK2;

	var NN = KK1 + KK2;

	var BB1 = parseFloat(document.getElementById("cell2_1").value);
	var BB2 = parseFloat(document.getElementById("cell2_2").value);
	var BB0 = BB1 + BB2;

	var PP = 0;  //片側確率

	BB1 = BB1 / BB0;
	BB2 = BB2 / BB0;

	var sBB1 = BB1;
	var sBB2 = BB2;

	var HH1 = KK1 / NN;
	var HH2 = KK2 / NN;

	var effectSizeG = Math.abs(HH1 - BB1);

	var strArray = [];
	var rcmArray = [];

	if ((BB1 === 0) || (BB1 === 1)) {
		strArray.push("[1x2](母比率不等)\n\n");
		strArray.push("注意！\n");
		strArray.push("母比率＝0 or 1です。\n");
		strArray.push("偶然分布は生じません。\n");
		strArray.push("\n\n  _/_/_/ Analyzed by js-STAR _/_/_/");
		document.getElementById("RltArea").value = strArray.join("");
		strArray = null;
	} else {
		strArray.push("[1x2](母比率不等)\n\n");
		strArray.push("---------------------------------------------\n");
		strArray.push("観測値\t\t" + using(KK1, 5, 0) + "\t" + using(KK2, 5, 0) + "\n");
		strArray.push("標本比率\t(" + using(HH1, 1, 4) + ") (" + using(HH2, 1, 4) + ")\n");
		strArray.push("---------------------------------------------\n");
		strArray.push("母比率\t\t" + using(BB1, 1, 4) + "\t" + using(BB2, 1, 4) + "\n");
		strArray.push("---------------------------------------------\n\n");

		if (KK1 > KK2) {
			dummy = KK1;
			KK1 = KK2;
			KK2 = dummy;

			dummy = BB1;
			BB1 = BB2;
			BB2 = dummy;
		}

		var temp;
		var R;
		if (KK1 < NN * BB1) {
			for (R = 0; R < KK1 + 1; R++) {
				temp = LogCombination(NN, R);
				PP = PP + Math.exp(temp + R * Math.log(BB1) + (NN - R) * Math.log(BB2));
			}
		} else {
			for (R = KK1; R < NN + 1; R++) {
				temp = LogCombination(NN, R);
				PP = PP + Math.exp(temp + R * Math.log(BB1) + (NN - R) * Math.log(BB2));
			}
		}

		var ppStr = "";
		if (PP < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}

		strArray.push("片側確率 : p=" + PP.toFixed(4) + ppStr + "\n\n");
		strArray.push("効果量 : g=" + effectSizeG.toFixed(4) + "\n");
		strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

		//出力
		if (document.getElementById("RltAdd").checked) {
			document.getElementById("RltArea").value += "\n\n" + strArray.join("");
		} else {
			document.getElementById("RltArea").value = strArray.join("");
		}
		strArray = null;

		//Ｒプログラム出力
		(function () {
			rcmArray.push("##### １×２表(母比率不等)\n");
			rcmArray.push("\n");
			rcmArray.push("### js-STARからの入力\n");
			rcmArray.push("ds1=" + sKK1.toFixed(0) + "         # 度数１\n");
			rcmArray.push("ds2=" + sKK2.toFixed(0) + "         # 度数２\n");
			rcmArray.push("\n");
			rcmArray.push("bo1=" + sBB1.toFixed(4) + "         # 母比率１\n");
			rcmArray.push("bo2=" + sBB2.toFixed(4) + "         # 母比率２\n");
			rcmArray.push("\n");
			var shinrai = document.getElementById("shinrai").value;
			rcmArray.push("shinrai= " + shinrai + " # 信頼水準\n");
			rcmArray.push("### js-STARから入力おわり\n");
			rcmArray.push("\n");
			rcmArray.push("# main\n");
			rcmArray.push("N= ds1+ds2\n");
			rcmArray.push("bo1= bo1/(bo1+bo2)\n");
			rcmArray.push("bo2= 1-bo1\n");
			rcmArray.push("\n");
			rcmArray.push("# 作図\n");
			rcmArray.push("dosu= c(ds1, ds2)   # 観測度数\n");
			rcmArray.push("bohi= c(bo1, bo2)   # 母比率\n");
			rcmArray.push("zhyo= matrix(c(bohi, dosu/N ), nc=2, by=1 )\n");
			rcmArray.push("rownames(zhyo)= c(\"母比率\", \"標本比率\")\n");
			rcmArray.push("maintitle=\"値１（黒）と値２（白）の比率\"\n");
			rcmArray.push("barplot(t(zhyo), hor=1, las=1, cex.ax=1.5, main=maintitle )\n");
			rcmArray.push("\n");
			rcmArray.push("# 作表\n");
			rcmArray.push("tx1= c()\n");
			rcmArray.push("tx1= matrix(round( c(dosu,dosu/N,bohi), 4), nr=3, by=1 )\n");
			rcmArray.push("rownames(tx1)= c(\"度　数\",\"標本比率 \",\"母比率\")\n");
			rcmArray.push("colnames(tx1)= c(\"値１\",\"      値２\" )\n");
			rcmArray.push("\n");
			rcmArray.push("# 効果量\n");
			rcmArray.push("ESg= ds1/N-bo1\n");
			rcmArray.push("kx1= chisq.test(dosu, p=c(bo1,bo2) )\n");
			rcmArray.push("ESw= sqrt( kx1$stat/N )\n");
			rcmArray.push("\n");
			rcmArray.push("# 両側\n");
			rcmArray.push("kr1= c()\n");
			rcmArray.push("kr1= binom.test(ds1, N, bo1, conf=shinrai )\n");
			rcmArray.push("\n");
			rcmArray.push("crD1= qbinom(0.025, N, bo1 )\n");
			rcmArray.push("if( pbinom(crD1, N, bo1)>0.025 ) crD1=crD1-1\n");
			rcmArray.push("crD2= qbinom(0.975, N, bo1 )\n");
			rcmArray.push("if( pbinom(crD2, N, bo1)<0.975 ) crD2=crD2+1\n");
			rcmArray.push("crD2= crD2+1\n");
			rcmArray.push("beta= sum( dbinom((crD1+1):(crD2-1), N, bo1+ESg) )\n");
			rcmArray.push("powR= 1-beta\n");
			rcmArray.push("\n");
			rcmArray.push("tr1= c()\n");
			rcmArray.push("tr1= matrix(round(c(kr1$p.v,abs(ESg),ESw,powR),4), nr=1 )\n");
			rcmArray.push("rownames(tr1)=\"両側検定\"\n");
			rcmArray.push("colnames(tr1)= c(\"   ｐ値\",\"効果量ｇ\",\"効果量ｗ\",\" 検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tr2= c()\n");
			rcmArray.push("tr2= matrix( c(kr1$conf[c(1,2)], \n");
			rcmArray.push("        binom.test(ds1,N,bo1, conf=0.90)$conf[c(1,2)],\n");
			rcmArray.push("        binom.test(ds1,N,bo1, conf=0.80)$conf[c(1,2)]), nr=3, by=1 )\n");
			rcmArray.push("rownames(tr2)= paste( c(95,90,80),\"\", sep=\"％信頼区間\" )\n");
			rcmArray.push("colnames(tr2)= c(\" 下限値\", \" 上限値\")\n");
			rcmArray.push("\n");
			rcmArray.push("# パワー\n");
			rcmArray.push("NN= c(NA,NA)\n");
			rcmArray.push("if( powR<0.80 )\n");
			rcmArray.push("{\n");
			rcmArray.push(" for( i in N:10000 )\n");
			rcmArray.push("{\n");
			rcmArray.push(" crD1= qbinom(0.025, i, bo1 )\n");
			rcmArray.push(" if( pbinom(crD1,i,bo1)>0.025 ) crD1=crD1-1\n");
			rcmArray.push(" crD2= qbinom(0.975, i, bo1 )\n");
			rcmArray.push(" if( pbinom(crD2,i,bo1)<0.975 ) crD2=crD2+1\n");
			rcmArray.push(" crD2= crD2+1\n");
			rcmArray.push(" beta= sum( dbinom((crD1+1):(crD2-1),i,bo1+ESg) )\n");
			rcmArray.push(" if( beta<0.20 ){ NN=c(i,1-beta,NN); break }\n");
			rcmArray.push("}\n");
			rcmArray.push("} else {\n");
			rcmArray.push(" for( i in N:0 )\n");
			rcmArray.push("{\n");
			rcmArray.push(" crD1= qbinom(0.025, i, bo1 )\n");
			rcmArray.push(" if( pbinom(crD1,i,bo1)>0.025 ) crD1=crD1-1\n");
			rcmArray.push(" crD2= qbinom(0.975, i, bo1 )\n");
			rcmArray.push(" if( pbinom(crD2,i,bo1)<0.975 ) crD2=crD2+1\n");
			rcmArray.push(" crD2= crD2+1\n");
			rcmArray.push(" beta= sum( dbinom((crD1+1):(crD2-1),i,bo1+ESg) )\n");
			rcmArray.push(" if( beta>0.20 ) break\n");
			rcmArray.push(" NN= c(i,1-beta, NN )\n");
			rcmArray.push("}\n");
			rcmArray.push("}\n");
			rcmArray.push("tr3= c()\n");
			rcmArray.push("tr3= matrix( round( c(abs(ESg),0.05,NN[2],NN[1],N), 4), nr=1 )\n");
			rcmArray.push("rownames(tr3)=\"\"\n");
			rcmArray.push("colnames(tr3)= c(\"効果量ｇ\",\"   α\",\"  検出力\",\"次回のＮ\",\"今回のＮ\" )\n");
			rcmArray.push("\n");
			rcmArray.push("# 片側\n");
			rcmArray.push("if( ESg>0 ){ kim=\"g\"; st=N; ed=0; tmp=\">\" } else { kim=\"l\"; st=0; ed=N; tmp=\"<\" }\n");
			rcmArray.push("kx9= binom.test(ds1,N,bo1, al=kim, conf=shinrai )\n");
			rcmArray.push("\n");
			rcmArray.push("crDS=NA; alph=0\n");
			rcmArray.push("for( i in st:ed )\n");
			rcmArray.push("{\n");
			rcmArray.push(" alph= alph+dbinom(i,N,bo1)\n");
			rcmArray.push(" if( alph>=0.05 ) break\n");
			rcmArray.push(" crDS= c(i, crDS)\n");
			rcmArray.push("}\n");
			rcmArray.push("crDS= crDS[1]\n");
			rcmArray.push("powK= sum( dbinom(st:crDS, N, prob=bo1+ESg) )\n");
			rcmArray.push("\n");
			rcmArray.push("tK1= c()\n");
			rcmArray.push("tK1= matrix( round( c(\n");
			rcmArray.push("     kx9$p.v, abs(ESg), ESw, powK), 4), nr=1 )\n");
			rcmArray.push("rownames(tK1)= paste(\"Ｈ0：値１\",tmp,\"母比率\", sep=\"\" )\n");
			rcmArray.push("colnames(tK1)= c(\"ｐ値\",\"効果量ｇ\",\"効果量ｗ\",\" 検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tK2= c()\n");
			rcmArray.push("tK2= matrix(kx9$conf[c(1,2)], nr=1 )\n");
			rcmArray.push("rownames(tK2)= paste(shinrai*100,\"％信頼区間\", sep=\"\" )\n");
			rcmArray.push("colnames(tK2)= c(\" 下限値\", \" 上限値\")\n");
			rcmArray.push("\n");
			rcmArray.push("\n");
			rcmArray.push("# ■結果の書き方\n");
			rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
			rcmArray.push("txt= c()\n");
			rcmArray.push("txt=\"　Table(tx1)は各値の度数集計表である。\n　Table(tx1)において，●●を母比率とする正確二項検定を行った結果，\"\n");
			rcmArray.push("\n");
			rcmArray.push("pch= tr1[1]\n");
			rcmArray.push("koka= round(tr1[3], 3)\n");
			rcmArray.push("kens= round(tr1[4], 3)\n");
			rcmArray.push("if( ds1==0 | ds2==0 ) fuki=paste(\" (p=\",PV(pch),\", w=\",koka,\", 両側検定)。\", sep=\"\" ) else\n");
			rcmArray.push("fuki= paste(\" (p=\",PV(pch),\", w=\",koka,\", 1-β=\",kens,\", 両側検定)。\", sep=\"\" )\n");
			rcmArray.push("\n");
			rcmArray.push("mds=paste(\"値１の標本比率\",round(ds1/N,3), sep=\"\"); goku=\"い傾向があった\"\n");
			rcmArray.push("if( pch<0.10 )\n");
			rcmArray.push("{\n");
			rcmArray.push(" if( ESg>0 ) tmp=\"大き\" else tmp=\"小さ\"\n");
			rcmArray.push(" if( pch<0.05 ) goku=\"かった\"\n");
			rcmArray.push(" txt= paste(txt, mds,\"が母比率\",round(bo1,3),\"よりも有意に\",tmp,goku,fuki, sep=\"\" )\n");
			rcmArray.push("} else {\n");
			rcmArray.push(" txt= paste(txt, mds,\"と母比率\",round(bo1,3),\"の差は有意ではなかった\",fuki, sep=\"\" )\n");
			rcmArray.push("}\n");
			rcmArray.push("\n");
			rcmArray.push("tmp= c()\n");
			rcmArray.push("if( koka>=0.49 ) tmp=\"大きい\" else\n");
			rcmArray.push("if( koka>=0.29 ) tmp=\"中程度以上\" else\n");
			rcmArray.push("if( koka>=0.26 ) tmp=\"ほぼ中程度)\" else tmp=\"小さい\"\n");
			rcmArray.push("txt= paste(txt, \"効果量wは便宜的基準 (Cohen, 1992) によると\",tmp,\"と判断される。\", sep=\"\" )\n");
			rcmArray.push("\n");
			rcmArray.push("goku=\"\"\n");
			rcmArray.push("if( pch<0.10 & ds1>0 & ds2>0 )\n");
			rcmArray.push("{\n");
			rcmArray.push(" fuki=\"検出力（1-β）は\"\n");
			rcmArray.push(" if( kens<0.70 ){ goku=\"ただし\"; tmp=\"不十分である\" } else\n");
			rcmArray.push(" if( kens<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない\" else\n");
			rcmArray.push(" if( kens<0.80 ) tmp=\"ほぼ十分といえる\" else tmp=\"十分である\"\n");
			rcmArray.push(" txt= paste(txt, goku,fuki,tmp,\"。\", sep=\"\" )\n");
			rcmArray.push("}\n");
			rcmArray.push("txt= paste(txt,\"\n\", sep=\"\" )\n");
			rcmArray.push("\n");
			rcmArray.push("if( shinrai==0.95 ){ gyo=1; if(pch>0.05 & pch<0.10) shinrai=0.90 }\n");
			rcmArray.push("if( shinrai==0.90 )  gyo=2\n");
			rcmArray.push("if( shinrai==0.80 )  gyo=3\n");
			rcmArray.push("\n");
			rcmArray.push("ci1= round(tr2[gyo,1], 3)\n");
			rcmArray.push("ci2= round(tr2[gyo,2], 3)\n");
			rcmArray.push("goku=\"。\"\n");
			rcmArray.push("if( pch>0.10 ) goku=\"。\n\"\n");
			rcmArray.push("txt= paste(txt, \"　F分布を用いた値１の比率の\",shinrai*100,\"％信頼区間は\",ci1,\" - \",ci2,\"と推定された\",goku, sep=\"\" )\n");
			rcmArray.push("\n");
			rcmArray.push("if( ESg>0 ) { mds=\"下\"; c.i=ci1 } else { mds=\"上\"; c.i=ci2 }\n");
			rcmArray.push("tmp=\"\"\n");
			rcmArray.push("if( pch<0.10)\n");
			rcmArray.push("{\n");
			rcmArray.push(" diff= abs( c.i-bo1 )\n");
			rcmArray.push(" dosa= N*diff\n");
			rcmArray.push(" goku=\"推測される。\"\n");
			rcmArray.push(" if( dosa>=1 ) dosa=trunc(dosa) else { dosa=\"1\"; goku=\"はいえない。\" }\n");
			rcmArray.push(" txt= paste(txt, \"信頼区間の\",mds,\"限\",round(c.i,3),\"は期待比率\",bo1,\"と\",round(diff,3),\"の比率差を示し，今回のN=\",N,\"のとき信頼水準\",shinrai*100,\"％で最少差が現実に度数\",dosa,\"以上の差を生じると\",goku, sep=\"\" )\n");
			rcmArray.push("} # if(pch)\n");
			rcmArray.push("txt= paste(txt, \"\n\n［引用文献］\n\",\n");
			rcmArray.push("\"Cohen, J. (1992). A power primer. Psychological Bulletin, 112, 155-159.\n\", sep=\"\" )\n");
			rcmArray.push("\n");
			rcmArray.push("\n");
			rcmArray.push("options(digits=4)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("################################\n");
			rcmArray.push("#\n");
			rcmArray.push("#   １×２表：母比率不等\n");
			rcmArray.push("#   正確二項検定（片側検定）\n");
			rcmArray.push("#\n");
			rcmArray.push("################################\n");
			rcmArray.push("tx1 # 度数集計表\n");
			rcmArray.push("\n");
			rcmArray.push("tK1 # 正確二項検定（片側検定）\n");
			rcmArray.push("\n");
			rcmArray.push("tK2 # 値１の比率の区間推定（Ｆ分布による）\n");
			rcmArray.push("\n");
			rcmArray.push("\n");
			rcmArray.push("################################\n");
			rcmArray.push("#\n");
			rcmArray.push("#   １×２表：母比率不等\n");
			rcmArray.push("#   正確二項検定（両側検定）\n");
			rcmArray.push("#\n");
			rcmArray.push("################################\n");
			rcmArray.push("tx1 # 度数集計表\n");
			rcmArray.push("\n");
			rcmArray.push("tr1 # 正確二項検定\n");
			rcmArray.push("# 効果量ｇの評価：大=0.25, 中=0.15, 小=0.05\n");
			rcmArray.push("# 効果量ｗの評価：大=0.50, 中=0.30, 小=0.10\n");
			rcmArray.push("# 度数=0があるとき検出力(1-β)は計算不能\n");
			rcmArray.push("\n");
			rcmArray.push("tr2 # 値１の比率の区間推定（Ｆ分布による）\n");
			rcmArray.push("# 検定結果が有意傾向のとき信頼水準=0.90に設定\n");
			rcmArray.push("\n");
			rcmArray.push("tr3 # パワーアナリシス（追試用Ｎの計算）\n");
			rcmArray.push("# ■ NA は計算中断。次回 N>10000 必要\n");
			rcmArray.push("\n");
			rcmArray.push("cat( txt) # 結果の書き方\n");
			rcmArray.push("\n");
			rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
			rcmArray.push("# write(txt, file.choose(), ap=T) # 結果のファイル保存\n");
			rcmArray.push("\n");
			rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
			rcmArray.push("\n");

			if (document.getElementById("RltAdd").checked) {
				document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
			} else {
				document.getElementById("RcmArea").value = rcmArray.join("");
			}
			rcmArray = null;
		}());	//Ｒプログラムここまで

		//グラフ描画
		(function () {
			if (document.getElementById("RltAdd").checked === false) {
				chartClear();
			}

			var parent = document.getElementById("chart");
			var childElementCount = parent.childElementCount;

			var i;
			var chartImg = document.createElement('canvas');
			chartImg.id = "ChartImg" + childElementCount;
			var ctx = document.getElementById("chart").appendChild(chartImg);

			var data = [];
			for (i = 0; i < 2; i++) {
				data[i] = [];
			}
			data[0][0] = (HH1 * 100).toFixed(4);
			data[0][1] = (sBB1 * 100).toFixed(4);
			data[1][0] = (HH2 * 100).toFixed(4);
			data[1][1] = (sBB2 * 100).toFixed(4);

			var datasetKey = [];
			for (i = 0; i < 2; i++) {
				datasetKey[i] = [];
			}
			for (i = 0; i < 2; i++) {
				datasetKey[i].label = '値' + (i + 1);
				datasetKey[i].data = data[i];
				datasetKey[i].backgroundColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
				datasetKey[i].borderColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
				datasetKey[i].borderWidth = 1;
			}

			var datasetData = [];
			// var dataset = [datas[0], datas[1]];
			for (i = 0; i < 2; i++) {
				datasetData[i] = datasetKey[i];
			}
			var myChart = new Chart(ctx, {
				type: 'horizontalBar',
				data: {
					labels: ['標本比率', '母比率'],
					datasets: datasetData
				},
				options: {
					title: {
						display: true,
						text: '値１（黒）と値２（灰白）の比率',
						position: 'top',
						fontSize: 12,
						fontColor: '#000000'
					},
					scales: {
						xAxes: [{
							stacked: true,
							ticks: {
								beginAtZero: true,
								min: 0,
								max: 100
							}
						}],
						yAxes: [{
							stacked: true
						}]
					},
					legend: {
						position: 'bottom'
					}
				}
			});
		}());	//グラフ描画ここまで

	}

	document.getElementById("RltArea").focus();
}
function sum() {
	var i = 1;
	var iCount = 1; // 観測値のみ合計する
	var jCount = 2;
	var elmCount = iCount * jCount;

	var wSum = 0;

	for (i = 1; i < elmCount + 1; i++) {
		if (isNaN(parseInt(document.getElementById("cell_" + i).value)) === false) {
			wSum += parseInt(document.getElementById("cell_" + i).value);
		}
	}
	document.getElementById("cell_sum").value = wSum;
}
function saveData_1x2futo() {
	var strArray = [];

	var KK1 = parseInt(document.getElementById("cell_1").value, 10);
	var KK2 = parseInt(document.getElementById("cell_2").value, 10);

	var BB1 = parseFloat(document.getElementById("cell2_1").value);
	var BB2 = parseFloat(document.getElementById("cell2_2").value);

	strArray.push(KK1 + "\t" + KK2 + "\n");
	strArray.push(BB1 + "\t" + BB2 + "\n");

	var Stream = strArray.join("");
	var fineName = "1x2futo_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function simulation_futo1x2(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	// var result = "rnd1:2*50";
	var N = 50;
	if (key_shift) {
		N = prompt("Nを入力してください");
		if (N !== "") {
			if (isNaN(N)) {
				N = 50;
			}
			N = parseInt(N, 10);
		}
	} else {
		if (document.getElementById("cell_sum").value !== "") {
			N = document.getElementById("cell_sum").value;
		} else {
			N = 50;
		}
	}

	var BB1;
	var BB2;

	var wBB1 = document.getElementById("cell2_1").value;
	var wBB2 = document.getElementById("cell2_2").value;

	if (isNaN(wBB1) || wBB1 === "") {
		BB1 = 1;
	} else {
		BB1 = parseFloat(document.getElementById("cell2_1").value);
	}
	if (isNaN(wBB2) || wBB2 === "") {
		BB2 = 2;
	} else {
		BB2 = parseFloat(document.getElementById("cell2_2").value);
	}

	var BB0 = BB1 + BB2;

	BB1 = BB1 / BB0;
	BB2 = BB2 / BB0;

	var wStr = "";
	for (i = 0; i < N; i++) {
		rand = Math.random();
		if (rand < BB1) {
			wStr += "1\n";
		} else {
			wStr += "2\n";
		}
	}

	document.getElementById("CandPArea").value = wStr;

	conditionalBranch();
	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// inputBtnTextClear(this);
	sum();
	document.getElementById("cell2_1").value = BB1.toFixed(4);
	document.getElementById("cell2_2").value = BB2.toFixed(4);

	mainCalc_futo1x2();
}
