/**
 * 分散分析
 * Ｑ検定（３水準以上の対応データ）
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeSaSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
function pValue_Qtest(Q, DF) {
	//.05<p<.10 有意傾向
	var P1 = new Array("2.706", "4.605", "6.251", "7.779", "9.236", "10.645", "12.017", "13.362", "14.684", "15.987", "17.275", "18.549", "19.812", "21.064", "22.307", "23.542", "24.769", "25.989", "27.204", "28.412", "29.615", "30.813", "32.007", "33.196", "34.382", "35.563", "36.741", "37.916", "39.088", "40.256", "51.805", "63.167", "74.397");
	//p<.05 ５％水準
	var P2 = new Array("3.841", "5.991", "7.815", "9.488", "11.071", "12.592", "14.067", "15.507", "16.919", "18.307", "19.675", "21.026", "22.362", "23.685", "24.996", "26.296", "27.587", "28.869", "30.144", "31.410", "32.671", "33.924", "35.173", "36.415", "37.653", "38.885", "40.113", "41.337", "42.557", "43.773", "55.759", "67.505", "79.082");
	//p<.01 １％水準
	var P3 = new Array("6.635", "9.210", "11.345", "13.277", "15.086", "16.812", "18.475", "20.090", "21.666", "23.209", "24.725", "26.217", "27.688", "29.141", "30.578", "32.000", "33.409", "34.805", "36.191", "37.566", "38.932", "40.289", "41.638", "42.980", "44.314", "45.642", "46.963", "48.278", "49.588", "50.892", "63.691", "76.154", "88.379");

	var wP1, wP2, wP3;
	var wDF = DF; //自由度
	var wx2 = Q; //Q値

	if (wDF < 30) {
		wP1 = P1[DF - 1];
		wP2 = P2[DF - 1];
		wP3 = P3[DF - 1];
	} else if (wDF < 40) {
		wP1 = P1[29];
		wP2 = P2[29];
		wP3 = P3[29];
	} else if (wDF < 50) {
		wP1 = P1[30];
		wP2 = P2[30];
		wP3 = P3[30];
	} else if (wDF < 60) {
		wP1 = P1[31];
		wP2 = P2[31];
		wP3 = P3[31];
	} else if (wDF >= 60) {
		wP1 = P1[32];
		wP2 = P2[32];
		wP3 = P3[32];
	}

	var ppStr = "";
	if (wx2 > wP3) {
		ppStr = "p<.01";
	} else if (wx2 > wP2) {
		ppStr = "p<.05";
	} else if (wx2 > wP1) {
		ppStr = ".05<p<.10";
	} else {
		ppStr = "ns";
	}

	return ppStr;
}
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			// if (LA === 2) {
			// 	mainCalc_McNemar();
			// }
			// if (LA > 2) {
			// 	mainCalc_Qtest();
			// }
			mainCalc_relateTest();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_McNemar() {
	var i = 0;
	var j = 0;
	var NN = 2;
	var AA = "A";
	var LA = 2;

	NN = parseInt(document.getElementById("subjNum").value, 10);
	AA = document.getElementById("factorA_name").value;
	LA = parseInt(document.getElementById("factorA_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = NN;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	var temp;
	if (document.getElementById("CandPArea").value === "") {
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				temp = parseInt(document.getElementById("cell_" + cellId).value, 10);
				// 0以下ならば0，そうでなければ1
				if (temp <= 0) {
					temp = 0;
				} else {
					temp = 1;
				}
				xx[i][j] = temp;
				cellId++;
			}
		}
	} else {
		var DData = document.getElementById("CandPArea").value;
		var dd = [];
		dd = DData.split(" ");

		var ddCount = 0;
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				temp = parseInt(dd[ddCount], 10);
				if (temp <= 0) {
					temp = 0;
				} else {
					temp = 1;
				}
				xx[i][j] = temp;
				ddCount++;
			}
		}
	}

	var strArray = [];
	var bar = "------------------------------------------------\n";

	var D = [[0, 0], [0, 0]];
	for (j = 0; j < NN; j++) {
		++D[xx[0][j]][xx[1][j]];
	}

	var P = [];
	P = p_keisan(D[0][0], D[0][1], D[1][0], D[1][1]);
	PP2 = P[0];
	PP = P[1];

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}
	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("[McNemar-Test（正確二項検定）]\n\n");
	strArray.push("\t0\t1\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("0:\t" + D[0][0] + "\t" + D[0][1] + "\n");
	// strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("1:\t" + D[1][0] + "\t" + D[1][1] + "\n");
	// strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	document.getElementById("RltArea").focus();
}
function mainCalc_relateTest() {
	var i = 0;
	var j = 0;
	var NN = 2;
	var AA = "A";
	var LA = 3;

	NN = parseInt(document.getElementById("subjNum").value, 10);
	AA = document.getElementById("factorA_name").value;
	LA = parseInt(document.getElementById("factorA_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = NN;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	var temp;
	if (document.getElementById("CandPArea").value === "") {
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				temp = parseInt(document.getElementById("cell_" + cellId).value, 10);
				// 0以下ならば0，そうでなければ1
				if (temp <= 0) {
					temp = 0;
				} else {
					temp = 1;
				}
				xx[i][j] = temp;
				cellId++;
			}
		}
	} else {
		var DData = document.getElementById("CandPArea").value;
		var dd = [];
		dd = DData.split(" ");

		var ddCount = 0;
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				temp = parseInt(dd[ddCount], 10);
				// 0以下ならば0，そうでなければ1
				if (temp <= 0) {
					temp = 0;
				} else {
					temp = 1;
				}
				xx[i][j] = temp;
				ddCount++;
			}
		}
	}

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//McNemar-Test
	if (LA === 2) {
		var D = [[0, 0], [0, 0]];
		for (j = 0; j < NN; j++) {
			++D[xx[0][j]][xx[1][j]];
		}

		var PP2 = 0;   //両側確率
		var PP = 0;    //片側確率

		var minD = Math.min(D[1][0], D[0][1]);
		var DN = D[1][0] + D[0][1];

		for (i = 0; i < minD + 1; i++) {
			PP = PP + Math.exp(LogCombination(DN, i) + DN * Math.log(0.5));
		}

		PP2 = PP * 2;
		if (PP2 >= 1) {
			PP2 = 0.9999;
		}

		var ppStr = "";
		if (PP2 < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP2 < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP2 < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}

		var pp2Str = "";
		if (PP < 0.01) {
			pp2Str = "   ** (p<.01)";
		} else if (PP < 0.05) {
			pp2Str = "   *  (p<.05)";
		} else if (PP < 0.10) {
			pp2Str = "   +  (.05<p<.10)";
		} else {
			pp2Str = "   ns (.10<p)";
		}

		strArray.push("[McNemar-Test（正確二項検定）]\n\n");
		strArray.push("\t1\t0\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("1:\t" + D[1][1] + "\t" + D[1][0] + "\n");
		// strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
		strArray.push("0:\t" + D[0][1] + "\t" + D[0][0] + "\n");
		// strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
		strArray.push("-----------------------------------------\n\n");
		strArray.push("\t(1-0)\t(0-1)\n");
		strArray.push("\t" + D[1][0] + "\t" + D[0][1] + "\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
		// strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");
	}

	//Cochran's Q
	if (LA > 2) {
		var G = [];
		var L = [];

		for (i = 0; i < LA; i++) {
			G[i] = 0;
			for (j = 0; j < NN; j++) {
				G[i] += xx[i][j];
			}
		}
		for (j = 0; j < NN; j++) {
			L[j] = 0;
			for (i = 0; i < LA; i++) {
				L[j] += xx[i][j];
			}
		}

		// 1と0の割合
		var ratio_1 = [];
		var ratio_0 = [];
		for (i = 0; i < LA; i++) {
			ratio_1[i] = G[i] / NN;
			ratio_0[i] = 1 - ratio_1[i];
		}

		var gg = 0;
		var ggg = 0;
		for (i = 0; i < LA; i++) {
			gg += G[i];
			ggg += Math.pow(G[i], 2);
		}
		var ll = 0, lll = 0;
		for (j = 0; j < NN; j++) {
			ll += L[j];
			lll += Math.pow(L[j], 2);
		}

		var Q = (LA - 1) * (LA * ggg - Math.pow(gg, 2)) / (LA * ll - lll);
		var DF = LA - 1;

		var ppStr = pValue_Qtest(Q, DF);

		strArray.push("[Cochran's Q]\n\n");

		var _str;
		strArray.push("  %");
		for (i = 0; i < LA; i++) {
			_str = "水準" + (i + 1);
			strArray.push("     " + _str);
		}
		strArray.push("\n");
		strArray.push("-----------------------------------------\n");

		strArray.push("  0\t");
		for (i = 0; i < LA; i++) {
			strArray.push(ratio_0[i].toFixed(3) + "\t");
		}
		strArray.push("\n");
		strArray.push("  1\t");
		for (i = 0; i < LA; i++) {
			strArray.push(ratio_1[i].toFixed(3) + "\t");
		}
		strArray.push("\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("x2(" + DF + ")=" + using(Q, 3, 3) + "  " + ppStr + "\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");
	}

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("####### 対応のある度数の分析 #######\n");
		rcmArray.push("####### マクネマー検定，Ｑ検定）\n");
		rcmArray.push("\n\n");
		rcmArray.push("## js-STARの入力\n");
		rcmArray.push("N= " + NN + "  # 人数\n");
		rcmArray.push("k= " + LA + "  # 選択肢の数=2以上\n");
		rcmArray.push("\n");
		rcmArray.push("dat = c(\n");
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				rcmArray.push(" " + xx[i][j]);
				if ((j != NN - 1) || (i != LA - 1)) {
					rcmArray.push(",");
				}
			}
			rcmArray.push("\n");
		}
		rcmArray.push(")\n");
		rcmArray.push("\n");
		var taju = document.getElementById("taju").value;
		if (LA === 2) taju = "BH";
		rcmArray.push("taju=\"" + taju + "\" # 多重比較(BH, holm, b)／２水準はBHのまま\n");
		rcmArray.push("## jsSTARからおわり\n");

		rcmArray.push("\n");
		rcmArray.push("## メイン\n");
		rcmArray.push("dx= matrix(dat, nc=k, by=1 )\n");
		rcmArray.push("tx1=c(); tx2=c(); tx3=c()\n");
		rcmArray.push("\n");
		rcmArray.push("# Q-test\n");
		rcmArray.push("if( k==2 )\n");
		rcmArray.push("{\n");
		rcmArray.push("ds11= sum( (dx[,1]+dx[,2])>1 )\n");
		rcmArray.push("ds10= sum( (dx[,1]-dx[,2])>0 )\n");
		rcmArray.push("ds01= sum( (dx[,1]-dx[,2])<0 )\n");
		rcmArray.push("ds00= sum( (dx[,1]+dx[,2])<1 )\n");
		rcmArray.push("tx1= matrix(c(ds11,ds10,ds01,ds00),nc=2, by=1 )\n");
		rcmArray.push(" rownames(tx1)= c(\"選　択\",\"非選択\")\n");
		rcmArray.push(" colnames(tx1)= c(\"選択\",\"非選択\")\n");
		rcmArray.push("} else {\n");
		rcmArray.push("gyoG= apply(dx, 2, sum )\n");
		rcmArray.push("rezG= apply(dx, 1, sum )\n");
		rcmArray.push("Qst= (k-1)*( k*sum(gyoG^2)-sum(dx)^2 ) / (k*sum(dx)-sum(rezG^2))\n");
		rcmArray.push("pch= pchisq(Qst, k-1, low=0 )\n");
		rcmArray.push("\n");
		rcmArray.push("tx1= matrix( c(gyoG, round(gyoG/N*100, 1), rep(N, k) ), nr=3, by=1 )\n");
		rcmArray.push("rownames(tx1)= c(\"選択数\", \"選択率(％)\",\"　　Ｎ\" )\n");
		rcmArray.push("colnames(tx1)= paste(\"選択肢\", 1:k, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("ESw = sqrt( Qst/N/(k-1) )\n");
		rcmArray.push("crX2= qchisq(0.95, k-1 )\n");
		rcmArray.push("beta= pchisq(crX2, k-1, ncp=Qst )\n");
		rcmArray.push("powX= 1-beta\n");
		rcmArray.push("tx2= matrix(round(c(Qst, k-1, pch, ESw, powX), 4), nc=5, by=1 )\n");
		rcmArray.push("rownames(tx2)=\"Ｑ検定\"\n");
		rcmArray.push("colnames(tx2)= c(\"χ2値\",\" df\",\"   ｐ値\",\"効果量ηQ\",\" 検出力\" )\n");
		rcmArray.push("} # if(k==2)else\n");
		rcmArray.push("\n");
		rcmArray.push("# McNemar\n");
		rcmArray.push("Tab=c(); powR=c() # 数値蓄積\n");
		rcmArray.push("mds= c()\n");
		rcmArray.push("for( x in 1:(k-1) ){\n");
		rcmArray.push("for( y in (x+1):k ){\n");
		rcmArray.push("  fugo= sign( dx[,x]-dx[,y] )    # 符号\n");
		rcmArray.push("  posC= sum( fugo[fugo>0] )      # ポジケース数(1, 0)\n");
		rcmArray.push("  negC= abs(sum( fugo[fugo<0] )) # ネガケース数(0, 1)\n");
		rcmArray.push("  Npn=posC+negC; if( Npn==0 ) Npn=1\n");
		rcmArray.push("  pval= binom.test(posC, Npn, 0.50 )$p.va\n");
		rcmArray.push("\n");
		rcmArray.push("ESg = posC/Npn-0.50\n");
		rcmArray.push("crD1= qbinom(0.025, Npn, 0.50 )\n");
		rcmArray.push("if( pbinom(crD1, Npn, 0.50)>0.025 ) crD1=crD1-1\n");
		rcmArray.push("crD2= qbinom(0.975, Npn, 0.50 )\n");
		rcmArray.push("if( pbinom(crD2, Npn, 0.50)<0.975 ) crD2=crD2+1\n");
		rcmArray.push("crD2= crD2+1\n");
		rcmArray.push("beta= sum( dbinom((crD1+1):(crD2-1), Npn, 0.50+ESg) )\n");
		rcmArray.push("if( abs(ESg)==0.50 ) beta=1\n");
		rcmArray.push("powR= c(powR, 1-beta )\n");
		rcmArray.push("if (posC + negC < 1) ESg = 0\n");
		rcmArray.push("\n");
		rcmArray.push("  Tab= c(Tab, posC, negC, pval )\n");
		rcmArray.push("  if( pval<0.10 ) if( posC>negC ) tmp=\"＞\" else tmp=\"＜\" else tmp=\"＝\"\n");
		rcmArray.push("  mds= c(mds, paste(\"選択肢\",x,tmp,y, sep=\"\") )\n");
		rcmArray.push("} }\n");
		rcmArray.push("tx3= matrix(round(Tab, 4), nc=3, by=1 )\n");
		rcmArray.push("tx3= cbind(tx3, p.adjust(tx3[,3], me=taju), round(powR,4) )\n");
		rcmArray.push("rownames(tx3)= mds\n");
		rcmArray.push("colnames(tx3)= c(\"(1-0)\",\"(0-1)\",\"   ｐ値\",\"adjust.p\",\" 検出力\")\n");
		rcmArray.push("\n");
		rcmArray.push("# ■結果の書き方\n");
		rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray.push("txt= paste(\"　Table(tx1)は，参加者\",N,\"名を対象に選択肢1～\",k,\"に対する複数選択を求めたときの回答を集計したものである。\n\", sep=\"\" )\n");
		rcmArray.push("mds=\"正確二項検定を用いたMcNemar検定\"\n");
		rcmArray.push("\n");
		rcmArray.push("if( k==2 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" txt= paste(txt, \"　\",mds,\"の結果，選択肢1と選択肢2に対する\", sep=\"\" )\n");
		rcmArray.push(" if (abs(ESg) == 0.50) fuki = paste(\"った (p=\", PV(pval), \", 効果量g=\", round(abs(ESg), 3), \", 両側検定)。\", sep = \"\") else\n");
		rcmArray.push(" fuki= paste(\"った (p=\",PV(pval),\", 効果量g=\",round(abs(ESg),3),\", 1-β=\",round(powR,3),\", 両側検定)。\", sep=\"\" )\n");
		rcmArray.push(" if( pval<0.10 )\n");
		rcmArray.push(" {\n");
		rcmArray.push("  if( posC>negC ) tmp=\"多\" else tmp=\"少な\"\n");
		rcmArray.push("  keko=\"い傾向があ\"; if( pval<0.05 ) keko=\"か\"\n");
		rcmArray.push("  txt= paste(txt, \"“選択‐非選択”の度数\",posC,\"が“非選択‐選択”の度数\",negC,\"よりも有意に\",tmp,keko,fuki, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("if (abs(ESg) < 0.50 & posC + negC > 0) {\n");
		rcmArray.push("goku=\"\"; tmp= \"\"; fuki=\"検出力（1-β）は\"\n");
		rcmArray.push("if( powR<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり、信頼性が低い\" } else\n");
		rcmArray.push("if( powR<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない\" else\n");
		rcmArray.push("if( powR<0.80 ) tmp=\"ほぼ十分といえる\" else tmp=\"十分である\"\n");
		rcmArray.push("txt= paste(txt, goku,fuki,tmp,\"。\\n\", sep=\"\" )\n");
		rcmArray.push("} else txt = paste(txt, \"\\n\", sep = \"\")\n");
		rcmArray.push("\n");
		rcmArray.push(" } else {\n");
		rcmArray.push("  txt= paste(txt, \"選択・非選択の度数に有意差は見られなか\",fuki,\"\\n\", sep=\"\" )\n");
		rcmArray.push(" }\n");
		rcmArray.push("} else { # ■ここからk>2\n");
		rcmArray.push("\n");
		rcmArray.push(" txt= paste(txt, \"　CochranのＱ検定を行った結果，\", sep=\"\" )\n");
		rcmArray.push(" fuki= paste(\" (χ2(\",k-1,\")=\",round(Qst,3),\", p=\",PV(pch),\", ηQ=\",round(ESw,3),\", 1-β=\",round(powX,3),\")。\", sep=\"\" )\n");
		rcmArray.push(" if( pch<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push("  keko=\"傾向\"; if( pch<0.05 ) keko=\"\"\n");
		rcmArray.push("  txt= paste(txt, \"有意\",keko,\"であった\",fuki, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("goku=\"\"; tmp= \"\"; fuki=\"検出力（1-β）は\"\n");
		rcmArray.push("if( powX<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり、信頼性が低い\" } else\n");
		rcmArray.push("if( powX<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない\" else\n");
		rcmArray.push("if( powX<0.80 ) tmp=\"ほぼ十分といえる\" else tmp=\"十分である\"\n");
		rcmArray.push("if( ESw<0.26 & powX<0.76 ) goku=\"\"\n");
		rcmArray.push("txt= paste(txt, goku,fuki,tmp,\"。\\n\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push(" txt= paste(txt, \"　多重比較として\",mds,\"を行った結果，\", sep=\"\" )\n");
		rcmArray.push(" yuis=sum( tx3[,4]<0.10 ); minP=min( tx3[,4] )\n");
		rcmArray.push(" if( yuis==0 ) txt=paste(txt, \"どの選択肢間にも有意な度数差は見いだされなかった (adjusted ps>\",PV(minP),\", 両側検定)。\", sep=\"\" ) else\n");
		rcmArray.push(" {\n");
		rcmArray.push("  gyos= nrow(tx3)\n");
		rcmArray.push("  gyo=0; sumi=0\n");
		rcmArray.push("  for( x in 1:(k-1) ){\n");
		rcmArray.push("  for( y in (x+1):k ){\n");
		rcmArray.push("   gyo= gyo+1\n");
		rcmArray.push("   posC=tx3[gyo,1]; negC=tx3[gyo,2]; pval=tx3[gyo,4]\n");
		rcmArray.push("   if( pval<0.10 )\n");
		rcmArray.push("   {\n");
		rcmArray.push("    sumi= sumi+1\n");
		rcmArray.push("    if( sumi==2 ) mata=\"同様に，\" else mata=\"\"\n");
		rcmArray.push("    fuki= paste(\" (adjusted p=\",PV(pval),\", 両側検定)\", sep=\"\" )\n");
		rcmArray.push("    if( posC>negC ) tmp=\"多\" else tmp=\"少な\"\n");
		rcmArray.push("    keko=\"い傾向が\"; if( pval<0.05 ) keko=\"\"\n");
		rcmArray.push("   if( sumi==1 | sumi==yuis ){ gok2=\"。\"; if(pval<0.05) gok1=\"かった\" else gok1=\"あった\" } else { gok2=\"，\"; if(pval<0.05) gok1=\"く\" else gok1=\"あり\" }\n");
		rcmArray.push("\n");
		rcmArray.push("   txt= paste(txt, mata,\"選択肢\",x,\"の選択数\",posC,\"が選択肢\",y,\"の選択数\",negC,\"よりも有意に\",tmp,keko,gok1,fuki,gok2, sep=\"\" )\n");
		rcmArray.push("   }\n");
		rcmArray.push("  } } # for(x,y)\n");
		rcmArray.push(" }    # if(yuis)\n");
		rcmArray.push("\n");
		rcmArray.push("if( taju==\"BH\" ) TAJ=\"Benjamini & Hochberg (1995) \"\n");
		rcmArray.push("if( taju==\"holm\" ) TAJ=\"Holm\"\n");
		rcmArray.push("if( taju==\"b\" ) TAJ=\"Bonferroni\"\n");
		rcmArray.push("txt= paste(txt, \"なお多重比較のp値の調整には\",TAJ,\"の方法を用いた。\\n\\n［引用文献］\\n\", sep=\"\" )\n");
		rcmArray.push("if( taju==\"BH\" ){ txt= paste(txt,\n");
		rcmArray.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" ) }\n");
		rcmArray.push("} else  # if(pch)\n");
		rcmArray.push("txt=paste(txt, \"有意ではなかった\",fuki,\"選択肢間の選択・非選択の度数に有意な差があるとは言えない。\\n\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("}  # if(k)else\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=4)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("############################\n");
		rcmArray.push("#   対応のある度数の検定\n");
		rcmArray.push("#\n");
		rcmArray.push("#  選択肢=2  McNemar test\n");
		rcmArray.push("#  選択肢>2  Cochran's Q\n");
		rcmArray.push("############################\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 # 度数集計\n");
		rcmArray.push("# 選択肢=2なら 行=選択肢1, 列=選択肢2\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # Ｑ検定(選択肢>2のとき参照する)\n");
		rcmArray.push("# 効果量ηQ = sqrt(χ2/回答者数/df)\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 # マクネマー検定（正確二項検定，両側）\n");
		rcmArray.push("# (1,0)=(選択-非選択), (0,1)=(非選択-選択)\n");
		rcmArray.push("# 度数 = 0があるとき検出力(1 - β)は計算不能\n");
		rcmArray.push("\n");
		rcmArray.push("cat(txt) # 結果の書き方\n");
		rcmArray.push("\n");
		rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# write(txt, file.choose(), ap=T) # 結果のファイル保存\n");
		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
// 要因Aの水準数セレクトのid subjNum
// 要因Aの名前 1行テキストボックスのid factorA_name
// 要因Aの水準数1行テキストボックスのid factorA_number
function changeSaSetting() {
	var h = 3;
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因名：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");

	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	//2のときマクマネー検定，3のときQ検定
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'水準数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("sa_setting").innerHTML = htmArray.join("");
	htmArray = null;
	changeSaTable();
}
function changeSaTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	// freqdata3を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");
	// htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("sa_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_sA() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);

	//#0
	strArray.push("sA" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#3
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#4
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sA_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sA() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sA") {
		var NN = crDel(dd[1]);
		var AA = crDel(dd[2]);
		var LA = crDel(dd[3]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		changeSaTable();
		document.getElementById("CandPArea").value = delTopCR(dd[4]);
	}
}
/**
 * [p_keisan 直接確率計算２ｘ２の計算]
 * @param  {int} A
 * @param  {int} B
 * @param  {int} C
 * @param  {int} D
 * @return {[float, float]}  戻り値は配列 [0]両側確率 [1]片側確率
 */
function p_keisan(A, B, C, D) {
	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M3  M4 | NN

	var NN = A + B + C + D;

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (var i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NN] = logfact(NN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}


	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	// if (PP2 >= 1) {
	// 	PP2 = 1.000; //直接確率計算２ｘ２ではこの処理は行っていない
	// }

	// if (PP >= 1) {
	// 	PP = 0.9999; //直接確率計算２ｘ２ではこの処理は行っていない
	// }

	return [PP2, PP];
}
