/**
 * SEM（共分散構造分析）
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	changeSemSetting();
	RoutputSelect();
	RoutputArea();

	make_X();
	make_F();
	make_A();
	makeFormula();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 観測変数
	// var elmCount = NN * (LA + 1);
	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = '';
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
}
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 観測変数
	var elmCount = NN * (LA + 1);

	var errorCellNum = 0;
	if (document.getElementById("CandPArea").value == "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value == "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sem();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sem() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 観測変数

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var xx = new Array(LA + 1);
	for (i = 0; i < LA + 1; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	//基本統計量
	var M = [];	//平均
	var SD = [];	//標準偏差
	var MA = [];	//最大値
	var MI = [];	//最小値

	strArray.push(" == Means & SDs(SDは標本標準偏差) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		MA[i] = xx[i][0];
		MI[i] = xx[i][0];

		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
			if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
		}

		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		strArray.push("x" + (i + 1) + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");

	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (i = 0; i < LA; i++) {
		strArray.push("x" + i + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
	}
	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		var Me = document.getElementById("Me").value;
		var Fix = document.getElementById("Fix").value;
		var formulaLength = document.getElementsByName("formula").length;
		var seLength = document.getElementsByName("se").length;
		var crLength = document.getElementsByName("cr").length;
		var aaaLength = document.getElementsByName("aaa").length;

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			for (j = 0; j < NN; j++) {
				for (i = 0; i < LA; i++) {
					rcmArray1.push(xx[i][j]);
					if ((i != LA - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			i = 0;
			for (i = 0; i < LA; i++) {
				rcmArray.push("x" + (i + 1) + " <- c(");
				for (j = 0; j < NN; j++) {
					rcmArray.push(" " + xx[i][j]);
					if ((j != NN - 1)) rcmArray.push(",");
				}
				rcmArray.push(" )\n");
			}
			rcmArray.push("\n");

			rcmArray.push("dtab <- data.frame(\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push(" x" + (i + 1));
				if ((i != LA - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");

			for (i = 0; i < LA; i++) {
				rcmArray.push("x" + (i + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("####### SEM（共分散構造分析） #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# パッケージ psych   が必要\n");
		rcmArray2.push("# パッケージ lavaan  が必要\n");
		rcmArray2.push("# パッケージ semPlot が必要\n");
		rcmArray2.push("# mF,mJ,dtabは読み込み済み\n");
		rcmArray2.push("\n");

		rcmArray2.push("## js-STARからの入力:SEM\n");
		rcmArray2.push("N=" + NN + "    # 人数\n");
		rcmArray2.push("hensu=" + LA + "  # 変数の数\n");
		rcmArray2.push("Me=\"" + Me + "\"  # 推定法 ml,wls,gls\n");
		rcmArray2.push("Fix=" + Fix + "    # 識別用(1=分散・残差固定)\n");
		rcmArray2.push("\n");

		rcmArray2.push("MDL= ' # モデル\n");
		var _me = "";
		for (i = 0; i < formulaLength; i++) {
			_me = document.getElementById("me_0_" + (i + 1)).value;
			rcmArray2.push(_me + "\n");
		}
		rcmArray2.push("' # MDLおわり\n");
		rcmArray2.push("\n");

		rcmArray2.push("## js-STARの入力おわり\n");
		rcmArray2.push("\n");

		rcmArray2.push("cat(\"■パッケージの読み込み中…\n\")\n");
		rcmArray2.push("library( lavaan ); library( semPlot )\n");
		rcmArray2.push("\n");
		rcmArray2.push("colnames(dtab)= paste(\"x\",1:hensu,sep=\"\")\n");
		rcmArray2.push("dx= data.frame(dtab[ ,1:hensu] )\n");
		rcmArray2.push("\n");
		rcmArray2.push("## 基本統計量\n");
		rcmArray2.push("hk= apply(dtab, 2, mean)\n");
		rcmArray2.push("sd= apply(dtab, 2,  sd)\n");
		rcmArray2.push("mi= apply(dtab, 2, min)\n");
		rcmArray2.push("ma= apply(dtab, 2, max)\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx1=c(); tx2=c(); tx3=c()\n");
		rcmArray2.push("tx4=c(); tx5=c(); tx6=c()\n");
		rcmArray2.push("tx1= matrix(round(c(rep(N,hensu),hk,sd,mi,ma,hk-sd,hk+sd),4), nc=7 )\n");
		rcmArray2.push("colnames(tx1)= c(\"N\",\" Mean\",\"SD\",\" Min\",\"Max\",\"   M-SD\",\"M+SD\" )\n");
		rcmArray2.push("rownames(tx1)= colnames(dtab)\n");
		rcmArray2.push("\n");
		rcmArray2.push("km= sem(MDL, data=dx,estimator=Me,std.lv=Fix )\n");
		rcmArray2.push("kx= attributes(km)$optim\n");
		rcmArray2.push("keis= kx$x # 推定値\n");
		rcmArray2.push("ncov= hensu*(hensu+1)/2\n");
		rcmArray2.push("tx2= matrix( c(kx$iter,ncov,kx$npar), nr=1 )\n");
		rcmArray2.push("if( kx$conv==1 ) tmp=\"収束しました\" else tmp=\"収束しませんでした\"\n");
		rcmArray2.push("rownames(tx2)= tmp\n");
		rcmArray2.push("colnames(tx2)= c(\"反復回数\",\"(共)分散の数\",\"母数の数\" )\n");
		rcmArray2.push("if( is.null(mF)<1 ) bang=nrow(mF)+1 else bang=1\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( kx$conv == 1 ){\n");
		rcmArray2.push("ky= fitMeasures( km )\n");
		rcmArray2.push("tx3= matrix(c(round(ky[3:5],3),round(ky[c(9,23:25)],4)), nc=7 )\n");
		rcmArray2.push("mds= paste(bang,\"】\",substr(Sys.time(),12,19), sep=\"\" )\n");
		rcmArray2.push("rownames(tx3)= mds\n");
		rcmArray2.push("colnames(tx3)= c(\"χ2\",\"df\",\"ｐ値\",\"CFI\",\"RMSEA\",\"CI下限\",\"   上限\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx4= matrix(round(ky[c(19,20,22)],4), nc=3 )\n");
		rcmArray2.push("rownames(tx4)= mds\n");
		rcmArray2.push("colnames(tx4)= c(\"    AIC\",\"    BIC\",\"  SABIC\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("ks= standardizedSolution( km ) # 標準化係数\n");
		rcmArray2.push("tx5= cbind( round(ks[ ,c(4:7)],3) )\n");
		rcmArray2.push("if( length(tx5)==0 ) tx5=c() else\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" kag=round(tx5[,1]-1.96*tx5[,2],3); kag[kag< -1 ]=-1\n");
		rcmArray2.push(" jog=round(tx5[,1]+1.96*tx5[,2],3); jog[jog>  1 ]=1\n");
		rcmArray2.push(" tx5= cbind(tx5, kag,jog )\n");
		rcmArray2.push(" rownames(tx5)= paste(ks$lhs,ks$op,ks$rhs,sep=\"\")\n");
		rcmArray2.push(" colnames(tx5)= c(\"    β\",\"s.e.\",\"ｚ値\",\"ｐ値\",\"95%CI下限\",\"上限\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("if( sum(is.nan(tx5[,1]))==0 & is.null(tx5)==0 ){ mF=rbind(mF,tx3); mJ=rbind(mJ,tx4) }\n");
		rcmArray2.push("\n");
		rcmArray2.push("noB= parameterEstimates(km, ci=T )\n");
		rcmArray2.push("# tx6= cbind( round(noB[,c(4,6:9)],3) )\n");
		rcmArray2.push("# rownames(tx6)= paste(ks$lhs,ks$op,ks$rhs,sep=\"\")\n");
		rcmArray2.push("# colnames(tx6)= c(\"非標準化係数\",\"ｚ値\",\"ｐ値\",\"95%CI下限\",\"上限\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 結果の書き方\n");
		rcmArray2.push("PV=function(x) floor(x*1000)/1000\n");
		rcmArray2.push("比較= function(mF,mJ)\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" Txt= paste(\"\nCFI  は モデル\",rownames(mF)[order(mF[,4],decreasing=T)[1] ],\"が最大です。\", sep=\"\" )\n");
		rcmArray2.push(" Txt= paste(Txt, \"\nRMSEAは モデル\",rownames(mF)[ order(mF[,5])[1] ],\"が最小です。\n\", sep=\"\" )\n");
		rcmArray2.push(" tmp=\"を支持します。\"\n");
		rcmArray2.push(" Txt= paste(Txt, \"\nAIC  は モデル\",rownames(mJ)[ order(mJ[,1])[1] ],tmp, sep=\"\" )\n");
		rcmArray2.push(" Txt= paste(Txt, \"\nBIC  は モデル\",rownames(mJ)[ order(mJ[,2])[1] ],tmp, sep=\"\" )\n");
		rcmArray2.push(" Txt= paste(Txt, \"\nSABICは モデル\",rownames(mJ)[ order(mJ[,3])[1] ],tmp,\"\n\", sep=\"\" )\n");
		rcmArray2.push(" cat(Txt)\n");
		rcmArray2.push("}\n");
		rcmArray2.push("hoho=c()\n");
		rcmArray2.push("if(Me==\"ml\") hoho=\"最尤法\"\n");
		rcmArray2.push("if(Me==\"wls\") hoho=\"重み付き最小二乗法\"\n");
		rcmArray2.push("if(Me==\"gls\") hoho=\"一般化最小二乗法\"\n");
		rcmArray2.push("txt=\"　各変数の基本統計量をTable(tx1)に示す。\"\n");

		rcmArray2.push("txt= paste(txt, \"\n");
		rcmArray2.push("　研究仮説に基づいたモデル1】～ \",bang,\"】を構築し，それぞれについて\",hoho,\"を用いた構造方程式モデリングを行った。\n");
		rcmArray2.push("　その結果，\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("badM= paste(\"モデル\",bang,\"】の\", sep=\"\" )\n");
		rcmArray2.push("if( kx$conv<1 ) txt=paste(txt, badM,\"推定計算は収束せず，有望なモデルは構成されなかった。\n");
		rcmArray2.push("\", sep=\"\" ) else\n");
		rcmArray2.push("if( sum(is.nan(tx5[,1]))>0 | is.null(tx5)==1 ) txt=paste(txt, badM,\"係数の推定が計算不能になった。参考までに分析を進めたが，出力された分析結果には信頼性がない。\n");
		rcmArray2.push("\", sep=\"\") else\n");
		rcmArray2.push("{ # if(sum(is.nan…\n");
		rcmArray2.push("txt= paste(txt, \"適合度指標において (Table(tx3)参照)，\", sep=\"\" ) # ★★修正\n");
		rcmArray2.push("cfi=ky[9]; rmsea=ky[23]\n");
		rcmArray2.push("if( rmsea>0.10 ) txt=paste(txt, \"十分な適合度を示すモデルは見いだされなかった (CFI=\",PV(cfi),\", RMSEA=\",PV(rmsea),\")。参考までにモデル\",bang,\"】のパス図をFigure■に示す。\n");
		rcmArray2.push("\", sep=\"\" ) else\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" gyoF= order(mF[,5])[1]\n");
		rcmArray2.push(" mds= paste(\"Figure■に示したモデル\",gyoF,\"】【※要確認】が他のモデルに比べて\", sep=\"\" )\n");
		rcmArray2.push(" fuk1= paste(\" (χ2(\",mF[gyoF,2],\")=\",round(mF[gyoF,1],3),\", p=\",PV(mF[gyoF,3]),\", CFI=\",PV(mF[gyoF,4]),\", RMSEA=\",PV(mF[gyoF,5]),\" [90%CI \",PV(mF[gyoF,6]),\" - \",PV(mF[gyoF,7]),\"])。\", sep=\"\" )\n");

		rcmArray2.push(" if( rmsea<0.05 ) tmp=\"最も良好な適合度を示した\" else tmp=\"許容される適合度を示した\"\n");
		rcmArray2.push("\n");
		rcmArray2.push(" txt= paste(txt, mds,tmp,fuk1,\"また，情報量規準の比較において (Table(tx4)参照)，\", sep=\"\" )\n");
		rcmArray2.push(" namJ= c(\"AIC\",\"BIC\",\"SABIC\")\n");
		rcmArray2.push(" mae=0; wamo=\"は\"\n");
		rcmArray2.push(" for( i in 1:3 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" gyoJ= order(mJ[,i])[1]\n");
		rcmArray2.push(" if( i>1 ) if( gyoJ!=mae ) wamo=\"は\" else wamo=\"も\"\n");
		rcmArray2.push(" if( i<3 ) goku=\"，\" else goku=\"た。\n\"\n");
		rcmArray2.push(" txt= paste(txt, namJ[i],wamo,\"モデル\",gyoJ,\"】を支持し\",goku, sep=\"\" )\n");
		rcmArray2.push(" mae= gyoJ\n");
		rcmArray2.push("}\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"\n\n⇒以下，Figure■において，有意性を示した標準化係数0.30以上のパスを中心に，次の３点について記述してください。\n　・プラスの影響か，マイナスの影響か\n　・影響の強さはどの程度か\n　・直接パスと間接パスはどちらが強いか\", sep=\"\" )\n");
		rcmArray2.push("txt= paste(txt, \"\n\n⇒SEMの知見はパス図で決まります。Figure■のパス図の整形をくり返してください。\n　①Ｒプログラム中の『■パスダイアグラムここから』～『■ここまで』の部分の各種オプションを変えてみる。\n　②変更後の■～■の部分をＲにコピペする。\n　③変更をくり返し，見栄えの良いFigureを完成する。\n\", sep=\"\" )\n");
		rcmArray2.push("} # if(rmsea<0.10)\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■パスダイアグラムここから\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("windows(); semPaths( km, what=\"path\",\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("quartz(); semPaths( km, what=\"path\",\n");
		}
		rcmArray2.push("  whatLabels=\"stand\", # stand,est,no,eq,name\n");
		rcmArray2.push("  style=\"lisrel\",     # lisrel,ram, mx, OpenMx\n");
		rcmArray2.push("  layout=\"tree\",  # tree2,circle,circle2,spring\n");
		rcmArray2.push("  residuals=1,    # 残差の表示/非表示(0)\n");
		rcmArray2.push("  exoCov=1,       # 因子間相関の表示/非表示(0)\n");
		rcmArray2.push("  rotation=1,     # 図の回転(1,2,3,4)\n");
		rcmArray2.push("  curve=1.3,      # 重なりパスの曲率(+ 外に湾曲)\n");
		rcmArray2.push("\n");
		rcmArray2.push("  edge.label.cex=1,   # パス係数の大きさ\n");
		rcmArray2.push("  edge.color=\"black\", # パスの色\n");
		rcmArray2.push("  residScale=10,      # 残差のパスの長さ\n");
		rcmArray2.push("  optimizeLatRes=T,   # 係数と残差の重なり補正\n");
		rcmArray2.push("  freeStyle= c(\"black\",1), # 自由パス\n");
		rcmArray2.push("  fixedStyle=c(\"black\",2), # 固定パス(2=破線,0=消去)\n");
		rcmArray2.push("\n");
		rcmArray2.push("  shapeMan=\"square\", # square(正方),rectangle(不等)\n");
		rcmArray2.push("  shapeLat=\"circle\", # circle(円形),ellipse(楕円)\n");
		rcmArray2.push("  sizeMan =5,  # 観測変数の四角のヨコ幅\n");
		rcmArray2.push("  sizeMan2=5,  # 観測変数の四角のタテ高(正方は無効)\n");
		rcmArray2.push("  sizeLat =8,  # 潜在変数の丸のヨコ幅\n");
		rcmArray2.push("  sizeLat2=8,  # 潜在変数の丸のタテ高(円形は無効)\n");
		rcmArray2.push("  # color= 1,  # 1,2,3,4,5,6,7,8 (不使用推奨)\n");
		rcmArray2.push("\n");
		rcmArray2.push("  # reorder=F, # manifests使用時実行(先頭#を消す)\n");
		rcmArray2.push("  # manifests=c(\"x3\",\"x1\",\"x2\"), # 配置順を指定\n");
		rcmArray2.push("  # nodeLabels=c(\"C\",\"A\",\"B\"),   # 名称の表示用\n");
		rcmArray2.push("\n");
		rcmArray2.push("  nDigits=2 # パス係数の小数点以下のケタ数\n");
		rcmArray2.push(")\n");
		rcmArray2.push("# ■ここまで\n");
		rcmArray2.push("\n");
		rcmArray2.push("} # if(is.nan)(kx$conv)\n");
		rcmArray2.push("H=matrix(0,nr=1)\n");
		rcmArray2.push("rownames(H)=\"\"\n");
		rcmArray2.push("colnames(H)=paste(\"推定法=\",hoho, sep=\"\" )\n");
		rcmArray2.push("tmp=\"識別オプションの変更またはモデルの改良を試みてください。\n\"\n");
		rcmArray2.push("if( kx$conv==0 ) txt=paste(txt, \"\n⇒\",tmp, sep=\"\" )\n");
		rcmArray2.push("if( is.null(tx5)==0 ) if( sum(abs(tx5[,1])>1, na.rm=1)>0 | sum(is.na(tx5[,1]))>0 ) txt=paste(txt, \"\n【注意】標準化パス係数（β）に不適解が生じています。\",tmp, sep=\"\" )\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("###########################\n");
		rcmArray2.push("#\n");
		rcmArray2.push("#  構造方程式モデリング\n");
		rcmArray2.push("#   （共分散構造分析）\n");
		rcmArray2.push("#\n");
		rcmArray2.push("H##########################\n");
		rcmArray2.push("tx1 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx2 # 推定計算の確認\n");
		rcmArray2.push("\n");
		rcmArray2.push("cat(MDL) # モデル表示\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx3 # 適合度指標\n");
		rcmArray2.push("# CIはRMSEAの90％信頼区間推定\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx4 # 情報量規準\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx5 # 標準化係数(β)\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 結果の書き方\n");
		rcmArray2.push("cat(txt)\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■オプション：[↑]⇒ 行頭の♯を消す⇒ [Enter]\n");
		rcmArray2.push("# library(psych);describe(dx) # 尖度,歪度ほか\n");
		rcmArray2.push("# round(cor(dx),3)  # 相関行列\n");
		rcmArray2.push("# summary(km,fit=T) # 現モデルの結果概要\n");
		rcmArray2.push("# predict( km )     # 潜在変数得点(因子得点)\n");
		rcmArray2.push("# noB # 非標準化パス係数(ｂ)\n");
		rcmArray2.push("# ky  # 各種適合度と情報量規準\n");
		rcmArray2.push("# mF;cat(\"\\n\");mJ;比較(mF,mJ) # モデル比較\n");
		rcmArray2.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで

	document.getElementById("RltArea").focus();
}
function changeSemSetting() {
	var h = 2;
	var htmArray = [];

	htmArray.push("<table border=\"0\" class=\"codetb2\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSemTableBranch();removeAllFormula();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSemTableBranch();removeAllFormula();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 10; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"10\" selected>10</option>");
		for (h = 11; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}

		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">観測変数の数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	if (thisBrowser.indexOf('ie') == -1) {
		// EV_numver  Explanatory Variable 観測変数
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"EV_number\" size=\"10\" min=\"2\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSemTableBranch();make_X();removeAllFormula();\">");
	} else {
		htmArray.push("<select id=\"EV_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'観測変数の項目数');changeSemTableBranch();make_X();removeAllFormula();\">");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("sem_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeSemTableBranch();
}
function changeSemTableBranch() {
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 観測変数

	if ((NN >= 10) || (LA + 1 >= 8)) {
		changeSemTable_scroll();
	} else {
		changeSemTable_all();
	}
}
function changeSemTable_all() {
	var i = 0;
	var j = 0;
	var k = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 観測変数
	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	htmArray.push("<div id=\"cellScroll\" class=\"cellScrolloff\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("x" + (i + 1));
		htmArray.push("</td>");
	}

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_3d\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
	}
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("sem_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function changeSemTable_scroll() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 観測変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	htmArray.push("<div id=\"tb_scroll_main\" class=\"tb_scroll_main\">");

	htmArray.push("<div id=\"divt0\" class=\"divtitle1\">");
	htmArray.push("<div id=\"div1\" class=\"div1\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku01\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_fact_title1\">参加者</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("<div id=\"div2\" class=\"div2\" onscroll=\"div2_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");
	htmArray.push("<tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		htmArray.push("<div>x" + (i + 1) + "</div>");
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"divt1\" class=\"divtitle2\">");
	htmArray.push("<div id=\"div3\" class=\"div3_fixed\" onscroll=\"div3_onscroll();\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_fact_title3\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"div4\" class=\"div4_fixed\" onscroll=\"div4_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("</div>"); //tb_scroll_main

	document.getElementById("sem_table").innerHTML = htmArray.join("");
	htmArray = null;
	document.getElementById('cellAreaScrollBtn').innerHTML = '▽全体';

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
/**
 * xの入力ボタン
 */
function make_X() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 観測変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var trCount = parseInt(LA / 10) + 1;
	if (LA % 10 == 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			htmArray.push("<td class=\"hyou_midashi_sem_X\">");
			if (LACount < LA) {
				htmArray.push("<div id=\"me_x" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">x" + (LACount + 1) + "</div>");
			} else {
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_x").innerHTML = htmArray.join("");
	htmArray = null;
}
/**
 * Fの入力ボタン
 */
function make_F() {
	var i = 0;
	var j = 0;
	var k = 0;

	var htmArray = [];
	var cellId = 1;

	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	for (i = 0; i < 9; i++) {
		htmArray.push("<td class=\"hyou_midashi_sem_F\">");
		htmArray.push("<div id=\"me_f" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">f" + (LACount + 1) + "</div>");
		htmArray.push("</td>");
		LACount++;
	}
	htmArray.push("<td class=\"hyou_midashi_sem_F\">");
	htmArray.push("<div id=\"me_f" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">g</div>");
	htmArray.push("</td>");

	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("sem_f").innerHTML = htmArray.join("");
	htmArray = null;
}
/**
 * 等号など入力ボタン
 */
function make_A() {
	var i = 0;
	var j = 0;
	var k = 0;

	var htmArray = [];
	var cellId = 1;

	var LACount = 0;
	var a = ["=~", "~", "~~", "+", "1", "0", "*", ".", ":", "Del"];

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	for (i = 0; i < 9; i++) {
		htmArray.push("<td class=\"hyou_midashi_sem_A\">");
		htmArray.push("<div id=\"me_a" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">" + a[i] + "</div>");
		htmArray.push("</td>");
		LACount++;
	}
	htmArray.push("<td class=\"hyou_midashi_sem_A\">");
	htmArray.push("<div id=\"me_a" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"delXF(event);\">" + a[9] + "</div>");
	htmArray.push("</td>");

	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("sem_a").innerHTML = htmArray.join("");
	htmArray = null;
}
function makeFormula() {
	var i = 0;
	var j = 0;
	var k = 0;

	var htmArray = [];

	var formulaLength = document.getElementsByName("formula").length;
	formulaLength++;

	htmArray.push("<div class=\"ME_formula\" name=\"formula\">");
	htmArray.push("<span id=\"del_ME_Formula_" + formulaLength + "\" class=\"delFormula\" onclick=\"delFormula('me'," + formulaLength + ");\" onmouseover=\"delFormulaOver(this);\" onmouseout=\"delFormulaOut(this);\">×</span>");
	htmArray.push("<span class=\"me_f\">" + String(formulaLength).padStart(2, "0") + "</span>");
	// htmArray.push("<input type=\"text\" class=\"me_0\" id=\"me_0_" + formulaLength + "\" name=\"me\" onclick=\"sortXF(event);\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\" onkeydown=\"keydownHandler(event);\">");
	htmArray.push("<input type=\"text\" class=\"me_0\" id=\"me_0_" + formulaLength + "\" name=\"me\" onclick=\"sortFormula(event);\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\" onkeydown=\"keydownHandler(event);\">");
	htmArray.push("<ul class=\"textChangeButton\">");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange('me'," + formulaLength + ",1);return false;\"><span>▼</span></a></li>");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange('me'," + formulaLength + ",-1);return false;\"><span>▲</span></a></li>");
	htmArray.push("</ul>");
	htmArray.push("<div>");

	var div_element = document.createElement("div");
	div_element.innerHTML = htmArray.join("");
	var parent_object = document.getElementById("sem_Formula");
	parent_object.appendChild(div_element);

	htmArray = null;
}
function removeFormula() {
	var formulaLength = document.getElementsByName("formula").length;
	if (formulaLength > 1) {
		var parent_object = document.getElementById("sem_Formula");
		parent_object.removeChild(sem_Formula.lastChild);
	}
}
function removeAllFormula() {
	var formulaLength = document.getElementsByName("formula").length;
	var parent_object = document.getElementById("sem_Formula");
	for (var i = 0; i < formulaLength - 1; i++) {
		parent_object.removeChild(sem_Formula.lastChild);
	}
	document.getElementById("me_0_1").value = "";
}
// ドラッグ時のハンドラ
function dragHandler(event) {
	// ドラッグ元のテキストをDataTransferオブジェクトに保持
	var orgText = event.target.innerHTML;
	event.dataTransfer.setData("text", orgText);
}
function dragoverHandler(event) {
	event.preventDefault();
	event.target.style.border = "solid 3px #ffaaaa";
}
function dragleaveHandler(event) {
	event.preventDefault();
	event.target.style.border = "solid 1px #999999";
}
// ドロップ時のハンドラ
function dropHandler(event) {
	// デフォルト処理のキャンセル
	event.preventDefault();

	// DataTransferオブジェクトからテキストを取得してドラッグ先のテキストに代入
	var addText = event.dataTransfer.getData("text");
	var orgText = event.target.value;

	var regexp = new RegExp(addText + "$"); //$は末尾指定 x1 は x11 にマッチしない
	if (orgText.match(regexp)) {
		event.target.value = "";
	} else {
		event.target.value = addText;
	}

	event.target.style.border = "solid 1px #999999";
}
// ドロップ時のハンドラ
function dropPlusHandler(event) {
	var key_event = event || window.event; //Firefox IE用
	// var key_ctrl = (key_event.ctrlKey);
	var key_shift = (key_event.shiftKey);

	var i;
	var dd = [];
	var outputText = "";
	var addTextFlag = false;

	// デフォルト処理のキャンセル
	event.preventDefault();

	var addText = event.dataTransfer.getData("text");
	var orgText = event.target.value;
	orgText = orgText.replace(/\s+/g, "");
	orgText = orgText.replace(/\+\+*/g, "+");
	if (orgText.slice(0, 1) == "+") {
		orgText = orgText.slice(1);
	}
	dd = orgText.split("+");

	if (addText.match(/x/) || addText.match(/f/)) {
		if (key_shift) {
			outputText = orgText + "+" + addText;
		} else {
			outputText = orgText + "" + addText;
		}
	} else {
		outputText = orgText + "" + addText;
	}

	if (addText === "Del") {
		outputText = "";
	}

	//スペースを削除
	outputText = outputText.replace(/\s+/g, "");
	//複数の＋を１つに
	outputText = outputText.replace(/\+\+*/g, "+");
	//先頭の＋を削除
	if (outputText.slice(0, 1) == "+") {
		outputText = outputText.slice(1);
	}
	outputText = outputText.replace(/\+/g, " + ");
	outputText = outputText.replace(/~~/g, "#");
	outputText = outputText.replace(/~/g, " ~ ");
	outputText = outputText.replace(/= ~/g, " =~");
	outputText = outputText.replace(/#/g, " ~~ ");

	event.target.value = outputText;

	event.target.style.border = "solid 1px #999999";
}
function keydownHandler(event) {
	var key_event = event || window.event; //Firefox IE用
	// var key_ctrl = (key_event.ctrlKey);
	var key_shift = (key_event.shiftKey);

	if (event.keyCode == 13) {
		var i;
		var dd = [];
		var outputText = "";
		var wStr = "";

		var orgText = event.target.value;
		orgText = orgText.replace(/\s+/g, "");
		orgText = orgText.replace(/\+\+*/g, "+");
		if (orgText.slice(0, 1) == "+") {
			orgText = orgText.slice(1);
		}

		outputText = orgText;

		//複数の＋を１つに
		outputText = outputText.replace(/\+\+*/g, "+");
		//先頭の＋を削除
		if (outputText.slice(0, 1) == "+") {
			outputText = outputText.slice(1);
		}
		//末尾の＋を削除
		if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
			outputText = outputText.slice(0, outputText.length - 1);
		}
		outputText = outputText.replace(/\+/g, " + ");
		outputText = outputText.replace(/~~/g, "#");
		outputText = outputText.replace(/~/g, " ~ ");
		outputText = outputText.replace(/= ~/g, " =~");
		outputText = outputText.replace(/#/g, " ~~ ");

		event.target.value = outputText;

		if (key_shift) {
			sortFormula(event);
		}
	}
}
/**
 * [inputXF xとFの入力]
 * クリックでテキストエリアにｘとFを入力する
 */
function inputXF(event) {
	//イベント処理
	var key_event = event || window.event; //Firefox IE用

	var key_ctrl = (key_event.ctrlKey);
	var key_shift = (key_event.shiftKey);
	var key_meta = (key_event.metaKey);

	var $name = event.target.className;
	var count = document.getElementsByName($name).length;

	var orgText = event.target.innerHTML;

	//キーに対応した処理
	var result = "";
	if (!key_shift) {
		if (key_ctrl || key_meta) {
			result = prompt("係数を入力してください");
			if (result === null) {
				result = "";
			}
			if (result !== "") {
				result = "+" + result + "*";
			}
		}
	}

	var outputText = "";
	var wStr = "";

	if (document.getElementById($name + "_0_" + count) != null) { //ME部分の入力
		wStr = document.getElementById($name + "_0_" + count).value;
		if (key_shift) {
			outputText = wStr + "+" + result + orgText;
		} else {
			outputText = wStr + result + orgText;
		}

		//スペースを削除
		outputText = outputText.replace(/\s+/g, "");
		//複数の＋を１つに
		outputText = outputText.replace(/\+\+*/g, "+");
		//先頭の＋を削除
		if (outputText.slice(0, 1) == "+") {
			outputText = outputText.slice(1);
		}
		// //末尾の＋を削除
		// if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
		// 	outputText = outputText.slice(0, outputText.length - 1);
		// }
		outputText = outputText.replace(/\+/g, " + ");
		outputText = outputText.replace(/~~/g, "#");
		outputText = outputText.replace(/~/g, " ~ ");
		outputText = outputText.replace(/= ~/g, " =~");
		outputText = outputText.replace(/#/g, " ~~ ");

		document.getElementById($name + "_0_" + count).value = outputText;
	}

}
function delXF(event) {
	//イベント処理
	var key_event = event || window.event; //Firefox IE用

	var key_ctrl = (key_event.ctrlKey);
	var key_shift = (key_event.shiftKey);
	var key_meta = (key_event.metaKey);

	var $name = event.target.className;
	var count = document.getElementsByName($name).length;

	var outputText = "";
	var wStr = "";

	if (document.getElementById($name + "_0_" + count) != null) { //ME部分の入力
		wStr = document.getElementById($name + "_0_" + count).value;
		outputText = wStr.substring(0, wStr.length - 1);
		document.getElementById($name + "_0_" + count).value = outputText;
	}
}
function setCursol(event) {
	var $name = event.target.className;
	var count = document.getElementsByName($name).length;

	var orgText = event.target.innerHTML;

	var str;
	var result, result1, result2;
	if (document.getElementById($name + "_0_" + count) != null) { //ME部分の入力
		str = document.getElementById($name + "_0_" + count).value;

		result = 0;
		result1 = 0;
		result2 = 0;
		if (str.lastIndexOf("*") !== -1) {
			result1 = str.lastIndexOf("*");
		}
		if (str.lastIndexOf("+") !== -1) {
			result2 = str.lastIndexOf("+") + 2;
		}
		if (result1 > result2) {
			result = result1;
		} else {
			result = result2;
		}

		document.getElementById($name + "_0_" + count).focus();
		// document.getElementById($name + "_0_" + count).setSelectionRange(result, result);
	}
}
function formulaTextChange(formulaNameId, IdNumber, upDown) {
	var id = formulaNameId;
	var idNum = IdNumber;
	var num = upDown;

	if (document.getElementById(id + "_0_" + (idNum + num)) != null) {
		$str = document.getElementById(id + "_0_" + idNum).value;
		document.getElementById(id + "_0_" + idNum).value = document.getElementById(id + "_0_" + (idNum + num)).value;
		document.getElementById(id + "_0_" + (idNum + num)).value = $str;
	}
}
function delFormula(formulaName, IdNumber) {
	var i;
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var Name = formulaName;
	var idNum = IdNumber;

	var Length = document.getElementsByName(Name).length;

	if (key_shift) {
		for (i = idNum + 1; i < Length + 1; i++) {
			formulaTextChange(Name, i, -1);
		}
		removeFormula();
	} else {
		document.getElementById("me_0_" + idNum).value = "";
	}
}
function delFormulaOver(obj) {
	obj.style.color = "#666666";
}
function delFormulaOut(obj) {
	obj.style.color = "#cccccc";
}
function sortFormula(event) {
	var i, j;

	var outputText = "";
	var orgText = event.target.value;

	orgText = orgText.replace(/\s+/g, "");
	orgText = orgText.replace(/\+\+*/g, "+");
	orgText = orgText.replace(/~~/g, "#");

	if (orgText.lastIndexOf("=~") > 0) {
		eqType = " =~ ";
		eqPosition = orgText.lastIndexOf("=~");
		rightText = orgText.substring(eqPosition + 2);
		leftText = orgText.substring(0, eqPosition);
	} else if (orgText.lastIndexOf("#") > 0) {
		eqType = " ~~ ";
		eqPosition = orgText.lastIndexOf("#");
		rightText = orgText.substring(eqPosition + 1);
		leftText = orgText.substring(0, eqPosition);
	} else if (orgText.lastIndexOf("~") > 0) {
		eqType = " ~ ";
		eqPosition = orgText.lastIndexOf("~");
		rightText = orgText.substring(eqPosition + 1);
		leftText = orgText.substring(0, eqPosition);
	} else {
		eqType = "";
		rightText = "";
		leftText = orgText;
	}

	leftText = sortXF(leftText);
	rightText = sortXF(rightText);

	event.target.value = leftText + eqType + rightText;
}
function sortXF(str) {
	var i, j;
	var dd = [];

	var wStr = str;
	var outputText = "";

	if (wStr.slice(0, 1) == "+") {
		wStr = wStr.slice(1);
	}
	dd = wStr.split("+");

	var count = document.getElementById("EV_number").value;
	var regexp;
	// f
	for (j = 1; j < 100; j++) { //f1～f99まで
		str = "f" + j;
		regexp = new RegExp(str + "$"); //$は末尾指定 f1 は f11 にマッチしない
		for (i = 0; i < dd.length; i++) {
			if (dd[i].match(regexp)) {
				outputText += "+" + dd[i];
				dd[i] = "";
			}
		}
	}
	// x
	for (j = 1; j < count + 1; j++) {
		str = "x" + j;
		regexp = new RegExp(str + "$"); //$は末尾指定 x1 は x11 にマッチしない
		for (i = 0; i < dd.length; i++) {
			if (dd[i].match(regexp)) {
				outputText += "+" + dd[i];
				dd[i] = "";
			}
		}
	}
	// x，f 以外
	for (i = 0; i < dd.length; i++) {
		if (dd[i] !== "") {
			outputText += "+" + dd[i];
		}
	}

	//複数の＋を１つに
	outputText = outputText.replace(/\+\+*/g, "+");
	//先頭の＋を削除
	if (outputText.slice(0, 1) == "+") {
		outputText = outputText.slice(1);
	}
	//末尾の＋を削除
	if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
		outputText = outputText.slice(0, outputText.length - 1);
	}

	outputText = outputText.replace(/\+/g, " + ");

	return outputText;
}
function saveModel() {
	var i, j;
	var strArray = [];

	strArray.push("SEM" + "\n");

	var formulaLength = document.getElementsByName("formula").length;
	strArray.push("#" + "\n");
	strArray.push(formulaLength + "\n");
	strArray.push("#" + "\n");
	var me_text = "";
	for (i = 0; i < formulaLength; i++) {
		me_text = document.getElementById("me_0_" + (i + 1)).value;
		strArray.push(me_text + "\n");
	}
	var Stream = strArray.join("");
	var fineName = "SEM_Model-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function readModel(ele) {
	var i, j;

	if (window.FileReader) {
		if (!ele.files.length) return;

		var file = ele.files[0];

		var fr = new FileReader();
		var FormulaData = "";
		var F_dd = [];
		fr.onload = function () {
			// try {
			FormulaData = fr.result;  // 読み込み結果
			F_dd = FormulaData.split("#");

			if (crDel(F_dd[0]) === "SEM") {
				removeAllFormula();
				make_X();
				make_F();
				make_A();

				var formulaLength = parseInt(F_dd[1]);
				for (i = 0; i < formulaLength - 1; i++) {
					makeFormula();
				}
				var me_text = F_dd[2];
				me_text = delTopCR(me_text);
				var _me_data = [];
				_me_data = me_text.split("\n");
				for (i = 0; i < formulaLength; i++) {
					document.getElementById("me_0_" + (i + 1)).value = _me_data[i];
				}
			} else {
				alert("データ形式が違います");
			}
		};
		fr.readAsText(file);  // ファイルをテキストとして読み込む
	}
}
function saveData_SEM() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 観測変数

	//#0
	strArray.push("SEM" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#3
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		strArray.push("\n");
	}

	var Stream = strArray.join("");
	var fineName = "SEM_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_SEM() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "SEM") {
		var NN = crDel(dd[1]);
		var LA = crDel(dd[2]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("EV_number").value = parseInt(LA, 10);
		changeSemTableBranch();

		document.getElementById("CandPArea").value = delTopCR(dd[3]);
	}
}
