/**
 * 分散分析
 * sA(１要因参加者内計画)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeSaSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === '') {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sA();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sA() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = NN;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = [];
	var mm;
	var SD = [];
	var sd;

	var MC$;
	var EQ$;

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ sA-Type Design ]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push("  A= " + AA + "\n");
	strArray.push(bar);
	strArray.push("A\tN\t\tMean\t\tS.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}

		M[i] = S / NN;
		mm = using(M[i], 5, 4);
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));
		sd = using(SD[i], 5, 4);
		strArray.push((i + 1) + "\t" + NN + "\t" + mm + "\t" + sd + "\t\n");
	}

	//分散分析
	// S.V    SS    df    MS    F
	// -----------------------------------
	// subj   SSUB  DS    MS
	//  A      A    DA    MA    FA    FA$
	// sxA     E    DE    ME
	// -----------------------------------
	// Total   T    DSAE

	// S.V    SS    df    MS    F     p
	// -----------------------------------
	// subj   SSs   DFs   MSs
	//  A     SSa   DFa   MSa   Fa    Pa
	// sxA    SSe   DFe   MSe
	// -----------------------------------
	// Total  SSt   DFt

	strArray.push(bar);
	strArray.push("\n == Analysis of Variance ==\n\n");
	strArray.push(" S.V        SS        df        MS        F\n");

	S = 0;
	for (i = 0; i < LA; i++) {
		S = S + M[i];
	}
	var DH = S / LA;
	var A = 0;
	var MD;
	for (i = 0; i < LA; i++) {
		MD = Math.pow(M[i] - DH, 2);
		A = A + MD * NN;
	}
	var SSUB = 0;
	SS = 0;
	for (j = 0; j < NN; j++) {
		S = 0;
		for (i = 0; i < LA; i++) {
			S = S + xx[i][j];
		}
		SSUB = SSUB + Math.pow(S, 2);
		SS = SS + S;
	}
	SSUB = SSUB / LA - Math.pow(SS, 2) / LA / NN;
	var E = 0;
	S = 0;
	for (i = 0; i < LA; i++) {
		S = S + Math.pow(SD[i], 2) * NN;
	}
	E = S - SSUB;
	var T = A + SSUB + E;
	var DA = LA - 1;
	var MA = A / DA;
	var DS = NN - 1;
	var MS = SSUB / DS;
	var DE = DA * DS;
	var ME = E / DE;
	var FA = MA / ME;
	var DSAE = DS + DA + DE;

	var D1 = DA;
	var D2 = DE;
	var Fdata = FA;
	var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var ssub = using(SSUB,10,4);
	// var ds = using(DS,4,0);
	// var ms = using(MS,8,4);
	// var a = using(A,11,4);
	// var da = using(DA,4,0);
	// var ma = using(MA,8,4);
	// var fa = using(FA,3,2);
	// var e = using(E,9,4);
	// var de = using(DE,4,0);
	// var me = using(ME,8,4);
	// var t = using(T,9,4);
	// var dsae = using(DSAE,4,0);

	strArray.push(bar);
	strArray.push(" subj" + using(SSUB, 10, 4) + " " + using(DS, 4, 0) + " " + using(MS, 8, 4) + "\n");
	strArray.push(bar);
	strArray.push("  A" + using(A, 11, 4) + " " + using(DA, 4, 0) + " " + using(MA, 8, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
	strArray.push(" sxA " + using(E, 9, 4) + " " + using(DE, 4, 0) + " " + using(ME, 8, 4) + "\n");
	strArray.push(bar);
	strArray.push("Total" + using(T, 9, 4) + " " + using(DSAE, 4, 0));
	strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	// strArray.push(bar);
	// strArray.push(" subj"+ssub+" "+ds+" "+ms+"\n");
	// strArray.push(bar);
	// strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");
	// strArray.push(" sxA "+e+" "+de+" "+me+"\n");
	// strArray.push(bar);
	// strArray.push("Total"+t+" "+dsae);
	// strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	//効果量
	var effectSizeF = Math.sqrt(DA / DE * FA);
	strArray.push("\n == EffectSize ==\n\n");
	strArray.push("\teffectsize f\n");
	strArray.push(bar);
	strArray.push("  A\t" + effectSizeF.toFixed(4) + "\n");
	strArray.push(bar);
	strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

	//多重比較
	var checkedLsd = false;
	var checkedHsd = false;
	var checkedBonf = false;
	var checkedHolm = false;

	checkedLsd = document.getElementById("LSD").checked;
	checkedHsd = document.getElementById("HSD").checked;
	checkedBonf = document.getElementById("BONF").checked;
	checkedHolm = document.getElementById("HOLM").checked;

	//多重比較 LSD
	if (checkedLsd) {
		if (FA$ != "ns") {
			if (LA > 2) {
				// var T2 = 0;
				var T2 = tvalue(D2);

				var LSD = T2 * Math.sqrt(2 * ME / NN);
				var lsd = using(LSD, 8, 4);

				strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(" (LSD=" + lsd + ")\n");
				strArray.push(bar);

				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (Math.abs(M[i] - M[ii]) > LSD) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 Bonferroni
	if (checkedBonf) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var kumi = 0;
				kumi = kumiawase(LA, 2);
				var TB = 0;
				TB = bonf_tValue(kumi, DE);
				var alpha_d = 0;
				alpha_d = using(0.05 / kumi, 2, 4);

				var BONF = TB * Math.sqrt(2 * ME / NA);
				var bonf = using(BONF, 7, 4);

				strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05 , alpha'=" + alpha_d + ")\n");
				strArray.push(" (BONF=" + bonf + ")\n");
				strArray.push(bar);

				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (Math.abs(M[i] - M[ii]) > BONF) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 Holm
	if (checkedHolm) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var kumi = 0;
				kumi = kumiawase(LA, 2);

				var TL = [];
				var TLN = []; //順番を保存
				var HMC$ = [];
				var alpha_d = [];

				var tlcount = 0;
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						TL[tlcount] = Math.abs(M[i] - M[ii]) / Math.sqrt(2 * ME / NA);
						TLN[tlcount] = tlcount;
						tlcount++;
					}
				}

				//TL値の小さい順に並び替え（同時にTLN値も）
				var temp;
				var temp2;
				for (i = 0; i < kumi; i++) {
					for (j = kumi - 1; j > 0; j--) {
						if (TL[j] < TL[j - 1]) {
							temp = TL[j];
							temp2 = TLN[j];
							TL[j] = TL[j - 1];
							TLN[j] = TLN[j - 1];
							TL[j - 1] = temp;
							TLN[j - 1] = temp2;
						}
					}
				}

				//TL値を計算
				var kflag = 1; //１のとき棄却する 0だと検定終了
				for (i = kumi; i > 0; i--) {
					if (kflag) {
						if (TL[i - 1] >= bonf_tValue(i, DE)) {
							HMC$[i - 1] = " *  ";
						} else {
							HMC$[i - 1] = "n.s.";
							kflag = 0; //検定終了 以降はすべて保留
						}
					} else {
						HMC$[i - 1] = "n.s.";
					}
					alpha_d[i - 1] = using(0.05 / i, 2, 4);
				}

				//TLN値の小さい順に並び替え
				var temp3;
				var temp4;
				for (i = 0; i < kumi; i++) {
					for (j = kumi - 1; j > 0; j--) {
						if (TLN[j] < TLN[j - 1]) {
							temp = TL[j];
							temp2 = TLN[j];
							temp3 = HMC$[j];
							temp4 = alpha_d[j];
							TL[j] = TL[j - 1];
							TLN[j] = TLN[j - 1];
							HMC$[j] = HMC$[j - 1];
							alpha_d[j] = alpha_d[j - 1];
							TL[j - 1] = temp;
							TLN[j - 1] = temp2;
							HMC$[j - 1] = temp3;
							alpha_d[j - 1] = temp4;
						}
					}
				}

				strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(bar);
				tlcount = 0;
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (HMC$[tlcount] == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						} else {
							EQ$ = "=";
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
						tlcount++;
					}
				}
				strArray.push(bar);
			}
		}
	}

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("####### 分散分析ｓＡ(１要因参加者内) #######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ psych が必要\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARの入力: sA\n");
		rcmArray.push("n    = c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push(NN);
			if (i != LA - 1) {
				rcmArray.push(",");
			}
		}
		rcmArray.push(")\n");
		rcmArray.push("\n");
		rcmArray.push("levA = " + LA + "\n");
		rcmArray.push("\n");
		rcmArray.push("data = c(\n");
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				rcmArray.push(" " + xx[i][j]);
				if ((j != NN - 1) || (i != LA - 1)) {
					rcmArray.push(",");
				}
			}
			rcmArray.push("\n");
		}
		rcmArray.push(")\n");
		rcmArray.push("\n");
		var taju = document.getElementById("taju").value;
		rcmArray.push("taju=\"" + taju + "\"  # BH, holm, b\n");
		rcmArray.push("## js-STARの入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("## スタック\n");
		rcmArray.push("s = gl(mean(n), levA)\n");
		rcmArray.push("A = gl(levA, 1, n[1]*levA)\n");
		rcmArray.push("sA= data.frame(s, A, data)\n");
		rcmArray.push("N = mean(n)\n");
		rcmArray.push("\n");
		rcmArray.push("## 基本統計量\n");
		rcmArray.push("Title=\"平均と標準偏差(不偏分散の平方根)\"\n");
		rcmArray.push("library( psych )\n");
		rcmArray.push("tx0=c(); txD=c()\n");
		rcmArray.push("for( i in 1:levA )\n");
		rcmArray.push("{\n");
		rcmArray.push(" kx= describe(subset(sA,A==i)$data )\n");
		rcmArray.push(" tx0= c(tx0, kx$n,kx$mean,kx$sd,kx$min,kx$max )\n");
		rcmArray.push(" txD= rbind(txD, kx[1,c(5,10:13)] )\n");
		rcmArray.push("}\n");
		rcmArray.push("tx0= matrix(round(tx0,4), nc=5,by=1 )\n");
		rcmArray.push("rownames(tx0)= paste(\"A.\",1:levA, sep=\"\" )\n");
		rcmArray.push("colnames(tx0)= c(\"   n\",\"    Mean\",\"     SD\",\"   Min\",\"   Max\" )\n");
		rcmArray.push("rownames(txD)= rownames(tx0)\n");
		rcmArray.push("colnames(txD)= \n");
		rcmArray.push("colnames(txD)= c(\"Median\",\"Range\",\"歪度\",\"尖度\",\"SE\" )\n");
		rcmArray.push("hk=tx0[ ,2]; sd=tx0[ ,3]\n");
		rcmArray.push("\n");
		rcmArray.push("## 作図\n");
		rcmArray.push("suij= 1:levA # 水準番号\n");
		rcmArray.push("bai=2 # ｙ軸の拡幅倍率\n");
		rcmArray.push("\n");
		rcmArray.push("for( L in 1:2 )\n");
		rcmArray.push("{\n");
		rcmArray.push("if( L==1 ) Sd=sd else { Sd=txD[,5]; Title=\"平均とSE(標準誤差)\" }\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray.push("windows() # ライン図\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray.push("quartz() # ライン図\n");
		}
		rcmArray.push("xjik= c(1-.3, levA+.3) # ｘ軸の拡幅\n");
		rcmArray.push("yjik= c(min(hk)-max(sd)*bai,max(hk)+max(sd)*bai)\n");
		rcmArray.push("plot(suij,hk, bty=\"l\",xli=xjik,yli=yjik,\n");
		rcmArray.push("  tck=0.03,  # 目盛り突起\n");
		rcmArray.push("  las=1,     # 目盛り正立\n");
		rcmArray.push("  xlab=\"水準番号\", ylab=\"平　均\",\n");
		rcmArray.push("  xaxt=\"n\",\n");
		rcmArray.push("  main=Title, cex.main=1.5,cex.lab=1.2 )\n");
		rcmArray.push("\n");
		rcmArray.push("meisho=paste(\"A\",1:levA,sep=\"\")\n");
		rcmArray.push("axis(side=1, at=1:levA, tck=0.03,labels=meisho )\n");
		rcmArray.push("arrows(suij,hk, suij,hk+Sd, lwd=L,ang=90,len=0.15 )\n");
		rcmArray.push("arrows(suij,hk, suij,hk-Sd, lwd=L,ang=90,len=0.15 )\n");
		rcmArray.push("lines (suij,hk, lwd=2,col=1)\n");
		rcmArray.push("points(suij,hk, pch=21,cex=3,bg=1 )\n");
		rcmArray.push("\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray.push("windows() # バー図\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray.push("quartz() # バー図\n");
		}
		rcmArray.push("mitsdo= c(0:(levA-1))*10*log(1:levA) # バーの斜線密度\n");
		rcmArray.push("xjik= c(0,   levA+1) # ｘ軸の拡幅：levA+1\n");
		rcmArray.push("shoh= min(min(hk),0) # 最小平均か,ゼロ\n");
		rcmArray.push("dais= max(sd)        # 最大ＳＤ\n");
		rcmArray.push("yjik=c(shoh+dais*bai*sign(shoh),max(hk)+dais*bai) # ｙ軸の範囲\n");
		rcmArray.push("\n");
		rcmArray.push("antx= barplot(hk, xli=xjik, yli=yjik,\n");
		rcmArray.push(" las=1, tck=0.02,     # ｙ軸の目盛\n");
		rcmArray.push(" col=1, den=mitsdo,   # バー斜線密度\n");
		rcmArray.push(" names.arg=paste(\"A\",1:levA,sep=\"\"),\n");
		rcmArray.push(" xlab=\"要因Ａ\", # ｘ軸ラベル名\n");
		rcmArray.push(" ylab=\"平　均\", # ｙ軸ラベル名\n");
		rcmArray.push(" main=Title, cex.main=1.5, cex.lab=1.2 )\n");
		rcmArray.push("arrows(antx,hk, antx,hk+Sd*sign(hk),lwd=L,ang=90,len=0.15 )\n");
		rcmArray.push("if(L==2) arrows(antx,hk,antx,hk-Sd*sign(hk),lwd=L,ang=90,len=0.15 )\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("# ANOVA\n");
		rcmArray.push("NAM=\"要因Ａ\"\n");
		rcmArray.push("kx= anova(lm(data~s+A,sA) )\n");
		rcmArray.push("SS=kx$S; DF=kx$D; MS=kx$M; Fch=kx$F; Pch=kx$P\n");
		rcmArray.push("eta= SS[2]/sum(SS[2:3])\n");
		rcmArray.push("tx1= c()\n");
		rcmArray.push("tx1= matrix(round(c(SS,DF,MS,Fch,Pch,NA,eta,NA),4), nc=6 )\n");
		rcmArray.push("rownames(tx1)= c(\"  ｓ\",NAM,\"ｓ×Ａ\" )\n");
		rcmArray.push("colnames(tx1)= c(\"SS\",\"df\",\"MS\",\"Ｆ\",\"ｐ\",\"   ηp2\" )\n");
		rcmArray.push("Fch=Fch[2]; Pch=Pch[2]\n");
		rcmArray.push("\n");
		rcmArray.push("tx3= c() # 多重比較\n");
		rcmArray.push("if( Pch<0.10 & levA>2 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" kx= pairwise.t.test(sA$data,sA$A,p.ad=taju, pair=1 )\n");
		rcmArray.push(" tx3= round(kx$p.v, 4)\n");
		rcmArray.push(" dimnames(tx3)= list(paste(\"A.\",2:levA,sep=\"\"),paste(\"A.\",1:(levA-1),sep=\"\") )\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("# hkR\n");
		rcmArray.push("dmat= matrix(data,nc=levA, by=1 )\n");
		rcmArray.push("rmat= cor(dmat)\n");
		rcmArray.push("keis= c()\n");
		rcmArray.push("for(x in 1:(levA-1)){ for(y in (x+1):levA) keis=c(keis,rmat[x,y] ) }\n");
		rcmArray.push("hkR= tanh( sum(nrow(dmat)*atanh(keis)) /( nrow(dmat)*length(keis) ) ) # Fisher.Z\n");
		rcmArray.push("if( sum(rmat<0)==0 | (sum(rmat<0)>0 & sum(rmat>0)==levA) ) mixR=0 else mixR=1\n");
		rcmArray.push("tmp= paste(\"A\",1:levA, sep=\"\" )\n");
		rcmArray.push("dimnames(rmat)= list(tmp,tmp)\n");
		rcmArray.push("\n");
		rcmArray.push("# 球面性\n");
		rcmArray.push("lmod= lm(dmat~1)\n");
		rcmArray.push("kx= mauchly.test(lmod, X=~1 )\n");
		rcmArray.push("MsW=kx$stat; MsP=kx$p.va\n");
		rcmArray.push("kx= anova(lmod,X=~1,test=\"Spherical\" )\n");
		rcmArray.push("eps= as.numeric(substr(attributes(kx)$head[5:6],29,34) )\n");
		rcmArray.push("tx9= c()\n");
		rcmArray.push("tx9= matrix(round(c(MsW,MsP,eps), 4), nc=4 )\n");
		rcmArray.push("rownames(tx9)=\"要因Ａ\"\n");
		rcmArray.push("colnames(tx9)= c(\"Mauchly's W\",\"   ｐ値\",\"  G-G_ε\",\" H-F_ε\" )\n");
		rcmArray.push("\n");
		rcmArray.push("crP= c()\n");
		rcmArray.push("eps[ eps>1 ]=1\n");
		rcmArray.push("GGp= pf(Fch,DF[2]*eps[1],DF[3]*eps[1],low=0 )\n");
		rcmArray.push("HFp= pf(Fch,DF[2]*eps[2],DF[3]*eps[2],low=0 )\n");
		rcmArray.push("crP= matrix(round(c(DF[2],Fch,Pch,GGp,HFp),4),nc=5 )\n");
		rcmArray.push("rownames(crP)= NAM\n");
		rcmArray.push("colnames(crP)= c(\"df\",\"Ｆ\",\"ｐ\",\" G-G_ｐ\",\" H-F_ｐ\")\n");
		rcmArray.push("\n");
		rcmArray.push("# パワ\n");
		rcmArray.push("ESf= sqrt(eta/(1-eta) )\n");
		rcmArray.push("NCP= ESf^2*N*levA\n");
		rcmArray.push("PWz=c(); PWr=c()\n");
		rcmArray.push("d1=DF[2]; d2=DF[3]\n");
		rcmArray.push("crF= qf(0.95,d1,d2 )\n");
		rcmArray.push("PWz= 1-pf(crF,d1,d2,NCP )\n");
		rcmArray.push("PWr= 1-pf(crF,d1,d2,NCP*( 1/(1-abs(hkR)) ))\n");
		rcmArray.push("tx2= c()\n");
		rcmArray.push("tx2= matrix(round(c(ESf,PWz,PWr,hkR),4), nc=4 )\n");
		rcmArray.push("rownames(tx2)= NAM\n");
		rcmArray.push("colnames(tx2)= c(\"効果量ｆ\",\" 検出力0\",\" 検出力r\",\" 水準間相関\")\n");
		rcmArray.push("if( mixR>0 ) Pow=PWz else Pow=PWr\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# ■結果の書き方\n");
		rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray.push("txt=c()\n");
		rcmArray.push("if( sum(sd==0)>0 ) txt=\"※分散=0 の水準があります。全データが同じ値です。以下の分析は信頼性がありません。\n\n\"\n");
		rcmArray.push("Tari=0 # 多重あり\n");
		rcmArray.push("fuki= paste(\" (F(\",d1,\",\",d2,\")=\",round(Fch,3),\", p=\",PV(Pch),\", ηp2=\",round(eta,3),\", 1-β=\",round(Pow,3),\")。\", sep=\"\" )\n");
		rcmArray.push("if( Pch<0.05 ) tmp=\"であった\" else\n");
		rcmArray.push("if( Pch<0.10 ) tmp=\"傾向であった\" else tmp=\"でなかった\"\n");
		rcmArray.push("txt= paste(txt, \"　各水準の○○得点について基本統計量をTable(tx0) or Fig.■に示す。\n　分散分析の結果 (Table(tx1)参照)，\",NAM,\"は有意\",tmp,fuki, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("goku=\"\"\n");
		rcmArray.push("if( Pch<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" if( Pow<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり，信頼性が低い。\" } else\n");
		rcmArray.push(" if( Pow<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない。\" else\n");
		rcmArray.push(" if( Pow<0.80 ) tmp=\"ほぼ十分といえる。\" else tmp=\"十分である。\"\n");
		rcmArray.push(" txt= paste(txt, goku,\"検出力 (1-β) は\",tmp, sep=\"\" )\n");
		rcmArray.push(" if( mixR>0 ) tmp=\"水準間の相関係数に正負が混在していたため平均相関を0と仮定し\" else tmp=\"Fisherの重み付きZ変換値による平均相関を用いて\"\n");
		rcmArray.push(" txt= paste(txt, \"なお検出力の値は\",tmp,\"算出した。\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("if( levA>2 )\n");
		rcmArray.push("{\n");
		rcmArray.push("shus= 0\n");
		rcmArray.push("if( is.nan(MsP)==1 ){ tmp=\"計算不能であった\"; MsP=NA; shus=shus+1 } else\n");
		rcmArray.push("  { if( MsP>=0.05 ) tmp=\"有意でなかったことを確認した\" else { tmp=\"有意であった\"; shus=shus+1 } }\n");
		rcmArray.push("fuki= paste(\" (Mauchly's W=\",round(MsW,3),\", p=\",PV(MsP),\")。\", sep=\"\" )\n");
		rcmArray.push("txt= paste(txt, \"\n　参加者内誤差についてMauchlyの球面性検定を行った結果 (Table(tx9)参照)，\",tmp,fuki, sep=\"\" )\n");
		rcmArray.push("if( (MsP<0.05 | is.na(MsP)>0) & shus>0 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   crp=crP[4]; fuki=\"\"; ika=\"\"\n");
		rcmArray.push("   if( crp<0.10 ){ tmp=\"であることを確認した\"; if(crp>0.05) fuki=\"傾向\" } else { tmp=\"性を得られなかった\"; ika=\"以下，参考までに分析を進める。\" }\n");
		rcmArray.push("   txt= paste(txt, \"このためGreenhouse-Geisserの自由度調整係数による修正検定を行った結果 (Table(crP)参照)，\",NAM,\"は有意\",fuki,tmp,\" (G-G corrected p=\",PV(crp),\")。\",ika, sep=\"\" )\n");
		rcmArray.push("  }\n");
		rcmArray.push("} # if(levA>)\n");
		rcmArray.push("\n");
		rcmArray.push("if( levA==2 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" if( hk[1]>hk[2] ) tmp=\"大きい\" else tmp=\"小さい\"\n");
		rcmArray.push(" if( Pch>0.05 ) fuki=\"傾向がある\" else fuki=\"\"\n");
		rcmArray.push(" txt= paste(txt, \"\n　\",goku,\"したがって，A1の平均\",round(hk[1],3),\"がA2の平均\",round(hk[2],3),\"よりも有意に\",tmp,fuki,\"ことが見いだされた。\", sep=\"\" )\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" Tari= 1\n");
		rcmArray.push(" okjun= c()\n");
		rcmArray.push(" okjun= order(rownames(tx0)[ rank(tx0[,2]) ], decreasing=1 )\n");
		rcmArray.push(" fuki=c(); tmp=c( rep(\",\",levA-1), \"\" ) # 区切り\n");
		rcmArray.push(" for(i in 1:levA) fuki=paste(fuki,\"A\",okjun[i],tmp[i], sep=\"\" )\n");
		rcmArray.push(" txt= paste(txt, \"\n　対応のあるｔ検定を用いた多重比較 (α=0.05, 両側検定) を行った結果 (Table(tx3)参照)，\", sep=\"\" )\n");
		rcmArray.push(" kazu= sum(tx3<0.10, na.rm=1 )\n");
		rcmArray.push(" minP= min(tx3, na.rm=1)\n");
		rcmArray.push(" if( kazu<1 ) txt= paste(txt, \"どの水準の平均の間にも有意差は見いだされなかった（adjusted ps>\",PV(minP),\")。\", sep=\"\" ) else\n");
		rcmArray.push(" { #####\n");
		rcmArray.push("txt= paste(txt, \"平均の大きい順 (\",fuki,\") に記述すると，\", sep=\"\" )\n");
		rcmArray.push("owa= 0\n");
		rcmArray.push("for(i in 1:(levA-1))\n");
		rcmArray.push("  {\n");
		rcmArray.push("   if( owa==0 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   if( i==2 ) mata=\"また，\" else mata=\"\"\n");
		rcmArray.push("   hk1= round(hk[okjun[i]], 3 )\n");
		rcmArray.push("   txt= paste(txt, mata,\"水準A\",okjun[i],\"の平均\",hk1,\"は\", sep=\"\" )\n");
		rcmArray.push("   yuiP=c(); sumi=0\n");
		rcmArray.push("for(j in (i+1):levA)\n");
		rcmArray.push("  {\n");
		rcmArray.push("   if( sumi==0 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   gyo=okjun[j]; rez=okjun[i]\n");
		rcmArray.push("   if( gyo>rez ) adP=tx3[gyo-1,rez] else adP=tx3[rez-1,gyo]\n");
		rcmArray.push("   if( adP<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"か\"\n");
		rcmArray.push(" if( i+1<j )\n");
		rcmArray.push("   {\n");
		rcmArray.push("    kt=1+(i-1)*3; bs=j-i-1; aida=substr(fuki,kt+3*1,1+kt+3*bs )\n");
		rcmArray.push("    kazu=length(yuiP); if(kazu>1) goku=\"ps>\" else goku=\"p=\"\n");
		rcmArray.push("    txt= paste(txt, aida,\"の平均と有意差がなく (adjusted \",goku,PV(yuiP[kazu]),\")，次の\", sep=\"\" )\n");
		rcmArray.push("   }\n");
		rcmArray.push(" hk2= round(hk[okjun[j]], 3 )\n");
		rcmArray.push(" tch= t.test(data~A, subset(sA, A==okjun[i] | A==okjun[j]), pair=1 )$stat\n");
		rcmArray.push(" txt= paste(txt,\"A\",okjun[j],\"の平均\",hk2,\"よりも有意に大き\",keko,\"った (t(\",N-1,\")=\",abs(round(tch,3)),\", adjusted p=\",PV(adP),\")。\", sep=\"\" )\n");
		rcmArray.push(" sumi= 1\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" yuiP= c(yuiP, adP )\n");
		rcmArray.push(" kazu=length(yuiP); if(kazu>1) goku=\"ps>\" else goku=\"p=\"\n");
		rcmArray.push(" if( j==levA ){ txt=paste(txt, \"以降の平均と有意差がなかった (adjusted \",goku,PV(yuiP[kazu]),\")。\", sep=\"\" ); owa=1 }\n");
		rcmArray.push("}\n");
		rcmArray.push("   }  }  }  } # for(i)(j)\n");
		rcmArray.push(" } #####\n");
		rcmArray.push("} # if(levA)\n");
		rcmArray.push("} # if(Pch)\n");
		rcmArray.push("\n");
		rcmArray.push("if( taju==\"BH\" ) TAJ=\"Benjamini & Hochberg (1995) \"\n");
		rcmArray.push("if( taju==\"holm\" ) TAJ=\"Holm\"\n");
		rcmArray.push("if( taju==\"b\" ) TAJ=\"Bonferroni\"\n");
		rcmArray.push("if( Tari>0 ) txt= paste(txt, \"\n　以上のp値の調整には\",TAJ,\"の方法を用いた。\", sep=\"\" )\n");
		rcmArray.push("txt= paste(txt,\"\n\",sep=\"\")\n");
		rcmArray.push("\n");
		rcmArray.push("if( Tari>0 & taju==\"BH\" ){ txt=paste(txt, \"\n［引用文献］\n\",\n");
		rcmArray.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" ) }\n");
		rcmArray.push("H=matrix(0,nr=1)\n");
		rcmArray.push("rownames(H)=\"\"\n");
		rcmArray.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("txt= paste(txt, \"\n\n⇒正規分布が仮定できない場合，または水準間の球面性が仮定できない場合は下の記述を参照あるいは追加してください。\n\", sep=\"\" )\n");
		rcmArray.push("kx= friedman.test(data~A|s, sA )\n");
		rcmArray.push("pc= kx$p.va\n");
		rcmArray.push("fuki= paste(\" (χ2(\",kx$para,\")=\",round(kx$stat,3),\", p=\",PV(pc),\")。\", sep=\"\" )\n");
		rcmArray.push("if( pc<0.05 ) tmp=\"であった\" else \n");
		rcmArray.push("if( pc<0.10 ) tmp=\"傾向であった\" else tmp=\"でなかった\"\n");
		rcmArray.push("txt= paste(txt, \"\n　Friedmanの順位和検定 (rank sum test) を行った結果，各水準の順位和の差は有意\",tmp,fuki, sep=\"\" )\n");
		rcmArray.push("if( pc<0.10 & levA>2 ) txt=paste(txt, \"Wilcoxonの符号化順位検定を用いた多重比較の結果は，Table(オプションのWilcox多重比較)の通りである (データにタイがある場合ｐ値は近似値)。p値の調整には\",TAJ,\"の方法を用いた。\", sep=\"\" )\n");
		rcmArray.push("txt= paste(txt,\"\n\",sep=\"\" )\n");
		rcmArray.push("fgoT=function()\n");
		rcmArray.push("{\n");
		rcmArray.push(" options(warn=-1 )\n");
		rcmArray.push(" round(pairwise.wilcox.test(sA$data,sA$A,p.ad=taju,pair=1)$p.va, 4 )\n");
		rcmArray.push("}\n");
		rcmArray.push("TesT= function(水準=1,相手=2)\n");
		rcmArray.push("{\n");
		rcmArray.push(" tx= t.test(data~A,subset(sA,A==水準 | A==相手), pair=1 )\n");
		rcmArray.push(" ttx= paste(\"t(\",N-1,\")=\",abs(round(tx$stat,4)),\", non-adjusted p=\",round(tx$p.va,4),\"(両側)\n\", sep=\"\" )\n");
		rcmArray.push(" cat(ttx)\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("##############################\n");
		rcmArray.push("#\n");
		rcmArray.push("#   分散分析 ｓＡ-design\n");
		rcmArray.push("#   １要因  参加者内計画\n");
		rcmArray.push("#\n");
		rcmArray.push("H#############################\n");
		rcmArray.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray.push("# 歪度,尖度,SEなどは『オプション』参照\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 # 分散分析ｓＡ\n");
		rcmArray.push("    # 効果量ηp2 は偏イータ２乗\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # 効果量ｆと検出力(1-β)\n");
		rcmArray.push("# 検出力0：水準間相関=0 (正負混在の場合)\n");
		rcmArray.push("# 検出力r：水準間相関=r (標本値から算出)\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 # ｔ検定による多重比較の調整後ｐ値\n");
		rcmArray.push("\n");
		rcmArray.push("tx9 # 球面性検定（df=1は不要）と自由度調整係数ε\n");
		rcmArray.push("crP # 球面性検定が有意のときの修正ｐ値\n");
		rcmArray.push("    # ■参加者数Ｎ≦10なら H-F_ｐ参照可\n");
		rcmArray.push("\n");
		rcmArray.push("cat(txt) # 結果の書き方\n");
		rcmArray.push("\n");
		rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# txD # Median,歪度,尖度,SEなど\n");
		rcmArray.push("# round(rmat,3) # 相関行列\n");
		rcmArray.push("# fgoT()        # Wilcox多重比較(調整後ｐ値)\n");
		rcmArray.push("# TesT(水準=1, 相手=2 ) # 任意の２水準のｔ検定\n");
		rcmArray.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = Math.round(M[i] * 10) / 10;
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = Math.round(M[i] * 10) / 10;
			if (min_y > M[i]) min_y = Math.round(M[i] * 10) / 10;
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}

		// 複合グラフを作成する
		datasetKey[0].label = ''; //ラベルを空白にする

		var graphType = document.getElementById("graphSelect").value;

		var start;
		var end;

		// 折れ線グラフ
		if (graphType === 'line') {
			start = 0;
			end = 2;
			datasetKey[1].label = 'A';
			datasetKey[1].data = data;
			datasetKey[1].backgroundColor = chartClrAry[0];
			datasetKey[1].borderColor = chartClrAry[0];
			datasetKey[1].pointBorderWidth = 3;
			datasetKey[1].borderWidth = 1;
			datasetKey[1].lineTension = 0;
			datasetKey[1].type = 'line';
		}

		// 棒グラフ
		if (graphType === 'bar') {
			end = 1;
			datasetKey[0].label = 'A';
			datasetKey[0].data = data;
			datasetKey[0].backgroundColor = chartClrAry[0];
			datasetKey[0].borderColor = chartClrAry[0];
			datasetKey[0].pointBorderWidth = 3;
			datasetKey[0].borderWidth = 1;
			datasetKey[0].lineTension = 0;
			datasetKey[0].type = 'bar';
		}

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('A' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < end; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];

		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
/**
 * [changeSaSetting id="sa_setting"の書き換え]
 *
 * 要因Aの水準数セレクトのid subjNum
 * 要因Aの名前 1行テキストボックスのid factorA_name
 * 要因Aの水準数1行テキストボックスのid factorA_number
 *
 */
function changeSaSetting() {
	var h = 3;
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因名：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'水準数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("sa_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeSaTable();
}
function changeSaTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sa_table").innerHTML = htmArray.join("");
	htmArray = null;
}
function saveData_sA() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);

	//#0
	strArray.push("sA" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#3
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#4
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sA_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sA() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sA") {
		var NN = crDel(dd[1]);
		var AA = crDel(dd[2]);
		var LA = crDel(dd[3]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		changeSaTable();
		document.getElementById("CandPArea").value = delTopCR(dd[4]);
	}
}
function simulation_sA(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var elmCount = LA * NN;

	var min, max;
	if ((LA === 2) && (NN === 2)) {
		min = 2;
		max = 5;
		LA = Math.floor(Math.random() * (max - min + 1) + min);
		min = 5;
		max = 30;
		NN = Math.floor(Math.random() * (max - min + 1) + min);
		elmCount = LA * NN;

		document.getElementById("subjNum").value = NN;
		document.getElementById("factorA_number").value = LA;

		changeSaTable();
	}

	var result = "rnd1:9*" + elmCount;

	document.getElementById("CandPArea").value = random_number_generation(result);

	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);

	mainCalc_sA();
}